#include <plib.h>
#include <stdio.h>
#include <ctype.h>
#include "disp.h"
#include "FSIO.h"
#include "config.h"
#include "other.h"
#include "debug.h"
#include "debug2.h"
#include "apps_hl.h"
#include "editor.h"
#include "compiler2.h"
#include "apps/ubasic.h"

//extern vars from core
extern unsigned char disp_buffer[160];
extern unsigned char key_mode;
extern int vreg_set;
extern kspec keys_spec;
extern unsigned volatile char key_char, key_stat;
extern char stdio_src;

unsigned char arrow_line;
unsigned char file_select[30];
FSFILE * file_gen;
int gen_dly;
unsigned char edit_device_line;
const unsigned char device_type_strings[6][6]= { "None.", "P18F.", "P18J.", "P18K.", "P18J1" };

//assembler variables
unsigned char deftable_l[DEFATABLE_LEN], deftable_r[DEFATABLE_LEN],eee;
UINT16 cfg_bits[8], output_file[OUTPUT_SIZE], debug_file[OUTPUT_SIZE];
UINT16 assembled_lines;
extern UINT16 line;

//debugger variables
int vreg_set;
//UINT16 output_file[OUTPUT_SIZE];
unsigned short int test_file[256];
DEVICE	device;
UINT16 debug_pc,flash_content;
unsigned char watch_vars[8],debug_c,debug_stat,debug_w,debug_linelen,debug_ll_count;
UINT16 watch_adr[8],debug_file_pointer,debug_actual_line,watch_flash[6];
unsigned char variable_p, variable_o,d_a_line,debug_show,debug_show_t,debug_mode,debug_cursor;
UINT16 debug_ram_addr,debug_flash_addr,hb_ram_base;
UINT16 bkp_addr,bkp_addr_temp;
unsigned char run_var;
debug_var debug_flags;
UINT16 edit_device_mask;
unsigned long flash_addr;

//editor variables
unsigned char input_file[INPUT_SIZE];
UINT16 file_len;
unsigned char editor_stat;


unsigned char param1[30],param2[30],param3[30],path1[30],path2[30],path_old[30],args_num;
unsigned char copy_buffer[32];
FSFILE * fp1,*fp2;
unsigned char p1[50];
SearchRec           searchRecord;
unsigned char count;

char *bprog;

unsigned char brk_parpath(unsigned char *input, unsigned char *param, unsigned char *path);
unsigned char is_fnchar (unsigned char dat);
unsigned char parse_cmdline (unsigned char * line);
unsigned char replace_str (unsigned char * str, unsigned char old, unsigned char new);
unsigned char file_cbf_save (FSFILE *file, DEVICE dev, UINT16 * cfg, UINT16 len, UINT16 * out, UINT16 * deb);
unsigned char file_cbf_load (FSFILE *file, DEVICE *dev, UINT16 * cfg, UINT16 len, UINT16 * out, UINT16 * deb);
unsigned char do_bf (unsigned char * code);


unsigned char app_de_start (unsigned char * args)
{
if (parse_cmdline (args)==2)
	{
	return 1;
	}
return 0;
}


unsigned char app_de_loop (unsigned char state)
{
UINT16 ppp;
unsigned char dat;
char str1[20];
if (state == 0)
	{
	for (debug_c=0;debug_c<6;debug_c++) watch_adr[debug_c] = debug_c;
	stdio_write("Debugger...");
	stdio_c(NEW_LINE);
	FSgetcwd(path_old, sizeof(path_old));
	FSchdir(path1);
	fp1 = FSfopen( param1, "r"); 
	if (fp1 == NULL)
		{
		return APP_RETVAL_FOE;
		}
	if (file_cbf_load(fp1,&device,cfg_bits,4096,output_file,debug_file)==1)
		stdio_write("File loaded");
	else
		stdio_write("File load failed");
	stdio_c(NEW_LINE);
	FSfclose(fp1);
	fp1 = FSfopen( param2, "r");
		if (fp1 == NULL)
		{
		return APP_RETVAL_FOE;
		}
	if (FSfread(input_file,1,sizeof (input_file),fp1)==0) return APP_RETVAL_FOE;
	FSfclose(fp1);
	state = 4;
	}

	if (state==4)		//debug
		{
		key_mode = 0;
		#ifdef	DEBUGGER
		if (device.type == P18F)
			{
			cfg_bits[0]=0x0800;
			cfg_bits[1]=0x0001;
			cfg_bits[2]=0x8000;
			cfg_bits[3]=0x0001;
			}
		if (device.type == P18FJ)
			{
			cfg_bits[0]=0xFF0E;
			cfg_bits[1]=0xFF04;
			cfg_bits[2]=0xFFFF;
			}
		if (device.type == P18FK)
			{
			cfg_bits[0]=0x0900;
			cfg_bits[1]=0x0001;
			cfg_bits[2]=0x8000;
			cfg_bits[3]=0x0001;
			}
		clear_disp_buffer();
		prog_enter_icsp(device);
		prog_enter_icsp(device);
		delay_ms(50);				
		ppp = prog_get_devid(device);		
		delay_ms(10);
		sprintf (str1,  "DEVID: 0x%04X\n",ppp);
		stdio_write(str1);
		sprintf (str1, "Erasing FLASH\n");
		stdio_write(str1);
		debug_erase_device(device);
		sprintf (str1, "Writing FLASH\n");
		stdio_write(str1);
		prog_write_flash(device);
		prog_write_cfgs(device);
		debug_write_de(device);
		ppp = prog_get_devid(device);
/*		flash_addr = 0x00000000;
		read_flash_out_t(flash_addr,512);
		flash_addr = 0x00200000;
		read_flash_out_t(flash_addr,512);
		flash_addr = 0x00007800;
		read_flash_out_t(flash_addr,512);
		sprintf (str1, " OK\n");
		stdio_write(str1);
		prog_leave_icsp(device);*/
		delay_ms(500);
		#endif
		state = 40;
		}

	if (state==40)		//reset and wait
		{
		#ifdef	DEBUGGER
		clear_disp_buffer();
		sprintf (str1, "RST target\n");	
		stdio_write(str1);
		rst_target();	
		sprintf (str1, "Waiting for DE\n");		
		stdio_write(str1);
		sprintf (str1, "esc/ent\n");	
		stdio_write(str1);
		#endif
		state=41;
		}

	if (state==41)		//reset and wait
		{
		#ifdef	DEBUGGER
		if (check_state()==1) 
			{
				sprintf (str1, "DE log OK\n");	
				stdio_write(str1);
				state = 42;
				delay_ms(500);
			}	
		if (keys_spec.esc)
			{
			keys_spec.esc = 0;
			state = 90;
			}
		if (keys_spec.ent)
			{
			keys_spec.ent = 0;
			sprintf (str1, " rst\n");	
			stdio_write(str1);
			rst_target();
			sprintf (str1, " end rst\n");	
			stdio_write(str1);

			}
		#endif
		}

	if (state==42)		//target responded, signature?
		{
		#ifdef	DEBUGGER
		if (bdm_r1w(0x08)==0xAA) 
			{
				sprintf (str1, " Sig. OK\n");	
				stdio_write(str1);
				state = 43;
			}	
			else state = 50;
		#endif
		}

	if (state==43)		//signature OK, ready
		{
		#ifdef	DEBUGGER
		sprintf ((char *)disp_buffer+64, " Ready");
		bkp_addr=0xFFFE;	
		bkp_addr_temp = bkp_addr;
		run_var = 2;
		delay_ms(500);
		#endif
		state = 48;
//		state = 44;
		}

	if (state==44)		//debug init
		{
		#ifdef	DEBUGGER
		di();
		hb_ram_base = ((UINT16)(device.ram_hb)) << 8;
		debug_pc = bdm_r2w(0x03);
		flash_content = debug_rfl (debug_pc);
		debug_stat = bdm_r1w2(4,hb_ram_base + 0x03);
		debug_w = bdm_r1w2(4,hb_ram_base + 0x04);
		clear_disp_buffer();
		if (debug_rfl(debug_pc) ==0xFFFF )
			sprintf ((char *)disp_buffer+0," <Empty>        ");
		else
			{
			debug_actual_line = debug_file[debug_pc/2];
			debug_file_pointer = find_line (debug_actual_line);
			debug_linelen = get_linelen(debug_file_pointer);
			sprintf ((char *)disp_buffer+0,"                ");
			for (debug_ll_count = 0; debug_ll_count<debug_linelen; debug_ll_count++)
				disp_buffer[debug_ll_count] = input_file[debug_file_pointer+debug_ll_count];
			disp_buffer[0] = '>';
			}
		if (debug_rfl(debug_pc+2) ==0xFFFF )
			sprintf ((char *)disp_buffer+16," <Empty>        ");
		else
			{
			debug_actual_line = debug_file[(debug_pc/2)+1];
			debug_file_pointer = find_line (debug_actual_line);
			debug_linelen = get_linelen(debug_file_pointer);
			sprintf ((char *)disp_buffer+16,"                ");
			for (debug_ll_count = 0; debug_ll_count<debug_linelen; debug_ll_count++)
				disp_buffer[16+debug_ll_count] = input_file[debug_file_pointer+debug_ll_count];
			}

		sprintf ((char *)disp_buffer+32,"RN SS RS EX      ");
		sprintf ((char *)disp_buffer+48,"WA RA FL BP      ");

		if (debug_show==D_S_WATCH)
			{
			watch_adr[0] = watch_adr[0]&0x0FFF;
			watch_adr[1] = watch_adr[1]&0x0FFF;
			watch_adr[2] = watch_adr[2]&0x0FFF;
			watch_adr[3] = watch_adr[3]&0x0FFF;
			watch_adr[4] = watch_adr[4]&0x0FFF;
			watch_adr[5] = watch_adr[5]&0x0FFF;
			if (debug_flags.update==0)
				{
				watch_vars[0] = bdm_r1w2(4,watch_adr[0]);
				watch_vars[1] = bdm_r1w2(4,watch_adr[1]);
				watch_vars[2] = bdm_r1w2(4,watch_adr[2]);
				watch_vars[3] = bdm_r1w2(4,watch_adr[3]);
				watch_vars[4] = bdm_r1w2(4,watch_adr[4]);
				watch_vars[5] = bdm_r1w2(4,watch_adr[5]);
				}
			sprintf ((char *)disp_buffer+64, "%03X:%02X %03X:%02X   ",watch_adr[0], watch_vars[0],watch_adr[1], watch_vars[1]);
			sprintf ((char *)disp_buffer+80, "%03X:%02X %03X:%02X   ",watch_adr[2], watch_vars[2],watch_adr[3], watch_vars[3]);
			sprintf ((char *)disp_buffer+96, "%03X:%02X %03X:%02X   ",watch_adr[4], watch_vars[4],watch_adr[5], watch_vars[5]);
			if (debug_flags.edit==1) disp_buffer[64 + 15] = 'e';
			if (debug_flags.edit==1) disp_buffer[80 + 15] = 'e';
			if (debug_flags.edit==1) disp_buffer[96 + 15] = 'e';
			sprintf ((char *)disp_buffer+112, "PC:%03X W:%02X S:%02X",debug_pc,debug_w, debug_stat);
			}
			
		if (debug_show==D_S_RAM)
			{
			watch_vars[0] = bdm_r1w2(4,debug_ram_addr);
			watch_vars[1] = bdm_r1w2(4,debug_ram_addr+1);
			watch_vars[2] = bdm_r1w2(4,debug_ram_addr+2);
			watch_vars[3] = bdm_r1w2(4,debug_ram_addr+3);
			sprintf ((char *)disp_buffer+64, "%03X:%02X %02X %02X %02X ",debug_ram_addr, watch_vars[0], watch_vars[1], watch_vars[2], watch_vars[3]);
			watch_vars[0] = bdm_r1w2(4,debug_ram_addr+4);
			watch_vars[1] = bdm_r1w2(4,debug_ram_addr+5);
			watch_vars[2] = bdm_r1w2(4,debug_ram_addr+6);
			watch_vars[3] = bdm_r1w2(4,debug_ram_addr+7);
			sprintf ((char *)disp_buffer+80, "%03X:%02X %02X %02X %02X ",debug_ram_addr+4, watch_vars[0], watch_vars[1], watch_vars[2], watch_vars[3]);
			watch_vars[0] = bdm_r1w2(4,debug_ram_addr+8);
			watch_vars[1] = bdm_r1w2(4,debug_ram_addr+9);
			watch_vars[2] = bdm_r1w2(4,debug_ram_addr+10);
			watch_vars[3] = bdm_r1w2(4,debug_ram_addr+11);
			sprintf ((char *)disp_buffer+96, "%03X:%02X %02X %02X %02X ",debug_ram_addr+8, watch_vars[0], watch_vars[1], watch_vars[2], watch_vars[3]);
			if (debug_flags.edit==1) disp_buffer[64 + 15] = 'e';
			if (debug_flags.edit==1) disp_buffer[80 + 15] = 'e';
			if (debug_flags.edit==1) disp_buffer[96 + 15] = 'e';
			sprintf ((char *)disp_buffer+112, "PC:%03X W:%02X S:%02X",debug_pc,debug_w, debug_stat);
			}
		if (debug_show==D_S_FLASH)
			{
			watch_flash[0] = debug_rfl(debug_flash_addr);
			watch_flash[1] = debug_rfl(debug_flash_addr+2);
			watch_flash[2] = debug_rfl(debug_flash_addr+4);
			watch_flash[3] = debug_rfl(debug_flash_addr+6);
			watch_flash[4] = debug_rfl(debug_flash_addr+8);
			watch_flash[5] = debug_rfl(debug_flash_addr+10);
			sprintf ((char *)disp_buffer+64, "%04X:%04X %04X  ",debug_flash_addr, watch_flash[0], watch_flash[1]);
			sprintf ((char *)disp_buffer+80, "%04X:%04X %04X  ",debug_flash_addr+4, watch_flash[2], watch_flash[3]);
			sprintf ((char *)disp_buffer+96, "%04X:%04X %04X  ",debug_flash_addr+8, watch_flash[4], watch_flash[5]);
			if (debug_flags.edit==1) disp_buffer[64 + 15] = 'e';
			if (debug_flags.edit==1) disp_buffer[80 + 15] = 'e';
			if (debug_flags.edit==1) disp_buffer[96 + 15] = 'e';
			sprintf ((char *)disp_buffer+112, "PC:%03X W:%02X S:%02X",debug_pc,debug_w, debug_stat);
			}
		if (debug_show==D_S_BKP)
			{
//			sprintf ((char *)disp_buffer+64, " code1          ",bkp_addr_temp-1);
//			sprintf ((char *)disp_buffer+80, " code2         ",bkp_addr_temp);
//			sprintf ((char *)disp_buffer+96, " code3         ",bkp_addr_temp+1);

			if (debug_rfl(bkp_addr_temp-2) ==0xFFFF )
				sprintf ((char *)disp_buffer+64," <Empty>        ");
			else
				{
				debug_actual_line = debug_file[bkp_addr_temp/2-1];
				debug_file_pointer = find_line (debug_actual_line);
				debug_linelen = get_linelen(debug_file_pointer);
				sprintf ((char *)disp_buffer+64,"                ");
				for (debug_ll_count = 0; debug_ll_count<debug_linelen; debug_ll_count++)
					disp_buffer[64 + debug_ll_count] = input_file[debug_file_pointer+debug_ll_count];
			}

			if (debug_rfl(bkp_addr_temp) ==0xFFFF )
				sprintf ((char *)disp_buffer+80," <Empty>        ");
			else
				{
				debug_actual_line = debug_file[bkp_addr_temp/2];
				debug_file_pointer = find_line (debug_actual_line);
				debug_linelen = get_linelen(debug_file_pointer);
				sprintf ((char *)disp_buffer+80,"                ");
				for (debug_ll_count = 0; debug_ll_count<debug_linelen; debug_ll_count++)
					disp_buffer[80 + debug_ll_count] = input_file[debug_file_pointer+debug_ll_count];
				}

			if (debug_rfl(bkp_addr_temp+2) ==0xFFFF )
				sprintf ((char *)disp_buffer+96," <Empty>        ");
			else
				{
				debug_actual_line = debug_file[bkp_addr_temp/2+1];
				debug_file_pointer = find_line (debug_actual_line);
				debug_linelen = get_linelen(debug_file_pointer);
				sprintf ((char *)disp_buffer+96,"                ");
				for (debug_ll_count = 0; debug_ll_count<debug_linelen; debug_ll_count++)
					disp_buffer[96 + debug_ll_count] = input_file[debug_file_pointer+debug_ll_count];
				}

			if (bkp_addr==bkp_addr_temp) disp_buffer[80 + 0] = '$';
			if (bkp_addr==bkp_addr_temp+1) disp_buffer[96 + 0] = '$';
			if (bkp_addr==bkp_addr_temp-1) disp_buffer[64 + 0] = '$';
			if (debug_flags.edit==1) disp_buffer[64] = '.';
//			if (debug_flags.edit==1) disp_buffer[80 + 15] = 'e';
			if (debug_flags.edit==1) disp_buffer[96] = '.';
			sprintf ((char *)disp_buffer+112, "A:%03X S:%03X    ",bkp_addr,bkp_addr_temp);
			}
		
		disp_buffer[(d_a_line*16)+debug_cursor] = disp_buffer[(d_a_line*16)+debug_cursor] | 0x80;
		ei();
//		delay_ms(100);
		#endif
		state = 45;
		}

	if (state==45)		//
		{
		#ifdef	DEBUGGER
		if (keys_spec.ent)		//reset
			{
			keys_spec.ent = 0;			
			if (d_a_line==2)
				{
				if (debug_mode == D_M_RUN)
					{
//					if (run_var==2) dat = bdm_r1w(0xFF);
					dat = bdm_r1w(0xFF);
					clear_disp_buffer();
			 		sprintf ((char *)disp_buffer+0, " Running...     ");
					sprintf ((char *)disp_buffer+16," Enter - stop   ");
					state = 47;
					run_var = 1;
					}
				if (debug_mode == D_M_SSTEP)
					{
					run_var = 1;
					keys_spec.bsp = 0;
					dat = bdm_r1w(0x07);
					dat = bdm_r1w(0xFF);
					state = 46;
					}
				if (debug_mode == D_M_RST)
					{
					state = 40;
					}

				if (debug_mode == D_M_EXIT)
					{
					return APP_RETVAL_OK;
					}
				}
			if (d_a_line==3)
				{
				debug_show = debug_show_t;
				state = 44;
				}
			if (d_a_line==5)
				{
				if (debug_show==D_S_BKP)
					{
					if (debug_flags.edit==1) 
						{
						state = 48;			//set_bkpt
						}
					}
				}
			}

		if (keys_spec.shf)
			{
			keys_spec.shf=0;
			if (debug_show==D_S_BKP)
				{
				if (d_a_line==5)
					{
					if (debug_flags.edit==1) 
						{
						debug_flags.edit = 0;
						if (debug_flags.update == 1)
							{
							debug_flags.update = 0;
							debug_write_ram(watch_adr[debug_flags.var],watch_vars[debug_flags.var]);
							}
						}
						else debug_flags.edit = 1;
					state = 44;
					}
				}
			else 
			if ((d_a_line>3)&(d_a_line<7))
				{
				if (debug_flags.edit==1) 
					{
					debug_flags.edit = 0;
					if (debug_flags.update == 1)
						{
						debug_flags.update = 0;
						debug_write_ram(watch_adr[debug_flags.var],watch_vars[debug_flags.var]);
						}
					}
					else debug_flags.edit = 1;
				state = 44;
				}
			}

		if (keys_spec.up)
			{
			keys_spec.up=0;
			if (debug_flags.edit==1)
				{
				if (debug_show==D_S_WATCH)
					{
					if (variable_p==0) watch_adr[(d_a_line-4)*2] = watch_adr[(d_a_line-4)*2] + (1<<4*(2-variable_o));
					if (variable_p==2) watch_adr[(d_a_line-4)*2+1] = watch_adr[(d_a_line-4)*2+1] + (1<<4*(2-variable_o));
					if (variable_p==1)	
						{
						watch_vars[(d_a_line-4)*2] = watch_vars[(d_a_line-4)*2] + (1<<4*(1-variable_o));
						debug_flags.var = (d_a_line-4)*2;
						debug_flags.update=1;
						}
					if (variable_p==3)	
						{
						watch_vars[(d_a_line-4)*2+1] = watch_vars[(d_a_line-4)*2+1] + (1<<4*(1-variable_o));
						debug_flags.var = 1+ ((d_a_line-4)*2);
						debug_flags.update=1;
						}
					state = 44;
					}
				if (debug_show==D_S_RAM)
					{
					if (d_a_line==4) debug_ram_addr = debug_ram_addr + (1<<4*(2-variable_o));
					state = 44;
					}
				if (debug_show==D_S_FLASH)
					{
					if (d_a_line==4) 
						{
						if (variable_o==3) debug_flash_addr = debug_flash_addr + (2<<4*(3-variable_o));
						else debug_flash_addr = debug_flash_addr + (1<<4*(3-variable_o));
						}
					state = 44;
					}
				if (debug_show==D_S_BKP)
					{
					bkp_addr_temp=bkp_addr_temp-2;
					state = 44;
					}
				}
			else
				{
				if (d_a_line==0) d_a_line = 8;
				d_a_line--;
				if (d_a_line==2) debug_mode=0;
				if (d_a_line==3) debug_show_t=0;
				debug_cursor=0;
				state = 44;
				}
			}

		if (keys_spec.dn)
			{
			keys_spec.dn=0;
			if (debug_flags.edit==1)
				{
				if (debug_show==D_S_WATCH)
					{
					if (variable_p==0) watch_adr[(d_a_line-4)*2] = watch_adr[(d_a_line-4)*2] - (1<<4*(2-variable_o));
					if (variable_p==2) watch_adr[(d_a_line-4)*2+1] = watch_adr[(d_a_line-4)*2+1] - (1<<4*(2-variable_o));
					if (variable_p==1)	
						{
						watch_vars[(d_a_line-4)*2] = watch_vars[(d_a_line-4)*2] - (1<<4*(1-variable_o));
						debug_flags.var = (d_a_line-4)*2;
						debug_flags.update=1;
						}
					if (variable_p==3)	
						{
						watch_vars[(d_a_line-4)*2+1] = watch_vars[(d_a_line-4)*2+1] - (1<<4*(1-variable_o));
						debug_flags.var = 1+ ((d_a_line-4)*2);
						debug_flags.update=1;
						}
						state = 44;
					}
				if (debug_show==D_S_RAM)
					{
					if (d_a_line==4) debug_ram_addr = debug_ram_addr - (1<<4*(2-variable_o));
					state = 44;
					}
				if (debug_show==D_S_FLASH)
					{
					if (d_a_line==4) 
						{
						if (variable_o==3) debug_flash_addr = debug_flash_addr - (2<<4*(3-variable_o));
						else debug_flash_addr = debug_flash_addr - (1<<4*(3-variable_o));
						}
					state = 44;
					}
				if (debug_show==D_S_BKP)
					{
					bkp_addr_temp=bkp_addr_temp+2;
					state = 44;
					}

				}
			else
				{
				d_a_line++;
				if (d_a_line==8) d_a_line = 0;
				debug_cursor=0;
				if (d_a_line==2) debug_mode=0;
				if (d_a_line==3) debug_show_t=0;
				state = 44;
				}
			}

		if (keys_spec.rt)
			{
			keys_spec.rt = 0;
			if (d_a_line==2)
				{
				debug_mode++;
				if (debug_mode >= D_M_LAST) debug_mode = 0;
				debug_cursor = debug_mode*3;
				}
			if (d_a_line==3)
				{
				debug_show_t++;
				if (debug_show_t >= D_S_LAST) debug_show_t = 0;
				debug_cursor = debug_show_t*3;
				}
			if ((d_a_line>3)&(d_a_line<7))
				if (debug_show==D_S_WATCH)
					{
					variable_o++;
					if ((variable_p % 2)==1)
						{
						if (variable_o>=2)
							{
							variable_o=0;
							variable_p++;
							if (variable_p==4) variable_p=0;
							}
						}
					else
						{
						if (variable_o>=3)
							{
							variable_o=0;
							variable_p++;
							if (variable_p==4) variable_p=0;
							}
						}
					if (variable_p==0) debug_cursor = variable_o;
					if (variable_p==1) debug_cursor = variable_o+4;
					if (variable_p==2) debug_cursor = variable_o+7;
					if (variable_p==3) debug_cursor = variable_o+11;
					}
			if (d_a_line==4)
				{
				if (debug_show==D_S_RAM)
					{
					variable_o++;
					if (variable_o>=3) variable_o=0;
					debug_cursor = variable_o;
					}
				if (debug_show==D_S_FLASH)
					{
					variable_o++;
					if (variable_o>=4) variable_o=0;
					debug_cursor = variable_o;
					}
				}
			state = 44;
			}

		if (keys_spec.lt)
			{
			keys_spec.lt = 0;
			if (d_a_line==2)
				{
				if (debug_mode <= 0) debug_mode = D_M_LAST;
				debug_mode--;
				debug_cursor = debug_mode*3;
				}
			if (d_a_line==3)
				{
				if (debug_show_t <= 0) debug_show_t = D_S_LAST;
				debug_show_t--;
				debug_cursor = debug_show_t*3;
				}
			if ((d_a_line>3)&(d_a_line<7))
				if (debug_show==D_S_WATCH)
					{
					if ((variable_p % 2)==1)
						{
						if (variable_o==0)
							{
							variable_o=2;
							if (variable_p<=0) variable_p=4;
							variable_p--;
							}
						else variable_o--;
						}
					else
						{
						if (variable_o==0)
							{
							variable_o=1;
							if (variable_p<=0) variable_p=4;
							variable_p--;
							}
						else variable_o--;
						}
					if (variable_p==0) debug_cursor = variable_o;
					if (variable_p==1) debug_cursor = variable_o+4;
					if (variable_p==2) debug_cursor = variable_o+7;
					if (variable_p==3) debug_cursor = variable_o+11;
					}
			if (d_a_line==4)
				if (debug_show==D_S_RAM)
					{
					if (variable_o<=0) variable_o=3;
					variable_o--;
					debug_cursor = variable_o;
					}
				if (debug_show==D_S_FLASH)
					{
					if (variable_o<=0) variable_o=4;
					variable_o--;
					debug_cursor = variable_o;
					}

			state = 44;
			}
		#endif
		}

	if (state==46)		//wait
		{
		#ifdef	DEBUGGER
		if (check_state()==1) 
			{
			if (bdm_r1w(0x08)==0xAA) state = 44;
				else state = 50;
			}
		if (keys_spec.esc)
			{
			keys_spec.esc = 0;
			state = 90;
			}
		#endif
		}


	if (state==47)		//running
		{
		#ifdef	DEBUGGER
		if (check_state()==1) 
			{
			if (bdm_r1w(0x08)==0xAA) state = 44;
			}
		if (keys_spec.ent)
			{
			keys_spec.ent=0;
	 		sprintf ((char *)disp_buffer+0, " Stopping...    ");
			sprintf ((char *)disp_buffer+16,"                ");
			if (bdm_entry()==0) state = 49;
			}
		if (keys_spec.esc)
			{
			keys_spec.esc = 0;
			state = 90;
			}
		#endif
		}
	if (state==48)		//set_bkpt
		{
		#ifdef	DEBUGGER
		sprintf ((char *)disp_buffer+112, 	"Setting bkpt... ");
		bkp_addr = bkp_addr_temp;
		bdm_r1w2(9,(bkp_addr>>1));
		state = 44;
		#endif
		}
	if (state == 49)	
		{
		clear_disp_buffer();		
		sprintf ((char *)disp_buffer+16,"  BDM timeout   ");	
		sprintf ((char *)disp_buffer+32,"  Enter - exit  ");		
		delay_ms(100);					
		if (keys_spec.ent)
			{
			keys_spec.ent = 0;
			state = 90;
			}
		}

	if (state == 50)	
		{
		clear_disp_buffer();
		sprintf (str1, " Sig err.\n");	
		stdio_write(str1);
		state = 90;
		}
	if (state == 90)
		{
		return	APP_RETVAL_UE;
		
		}	
	return state;
}

unsigned char app_test_init (unsigned char * args)
{

}

unsigned char app_test_loop (unsigned char state)
{
UINT16 verify_result;
	if (state==5)		//test target
		{
		prog_enter_icsp(device);
		prog_enter_icsp(device);
		delay_ms(5);		
		verify_result = prog_get_devid(device);
		state = 55;
		clear_disp_buffer();
		sprintf ((char *)disp_buffer+16, "  DEVID: 0x%04X",verify_result);
		}
		
	if (state==55)		//test target
		{
		if (keys_spec.ent)
			{
			prog_leave_icsp(device);
			keys_spec.ent = 0;
			state = 0;
			}
		}	

}


	/*
	device.type = P18FJ;
	device.eblock = 1024;
	device.wblock = 32;
	device.flash_write = 512;
	device.flash_erase = 512;
	device.flash_size = 0x3FFF;
	device.ram_hb = 0x03;
	device.debug_clock = 80;
	*/
	/*
	device.type = P18F;
	device.eblock = 32;
	device.wblock = 32;
	device.flash_write = 512;
	device.flash_erase = 512;
	device.flash_size = 0xFFFF;
	device.ram_hb = 0x0E;
	device.debug_clock = 80;
	*/
	/*
	device.type = P18FK;
	device.eblock = 32;				//in words, not bytes!!!
	device.wblock = 16;				//in words!!!
	device.flash_write = 512;		//words
	device.flash_erase = 512;		//words
	device.flash_size = 0x7FFF;		//last valid FLASH addr
	device.ram_hb = 0x05;			//last valid RAM bannk
	device.debug_clock = 80;
*/

unsigned char app_ls_start (unsigned char * args)
{
if (parse_cmdline (args)==1)
	{
	return 1;
	}	
else
	{
	strcpy(param1,"*.*");
	return 1;
	}
}

unsigned char app_ls_loop (unsigned char state)
{
unsigned char str1[30];
count = 0;
stdio_write("\n");
FSgetcwd(path_old, sizeof(path_old));
FSchdir(path1);
if (!FindFirst( param1, ATTR_DIRECTORY | ATTR_ARCHIVE | ATTR_READ_ONLY | ATTR_HIDDEN, &searchRecord ))
	{
	count++;
	if (searchRecord.attributes&ATTR_DIRECTORY)
		sprintf(str1, "%11s -DIR-\n", searchRecord.filename);
	else
		{
		if (searchRecord.filesize<1000)
			sprintf(str1, "%11s %ldB\n", searchRecord.filename, searchRecord.filesize );
		else if (searchRecord.filesize<1000000)
			sprintf(str1, "%11s %ldK\n", searchRecord.filename, searchRecord.filesize/1024 );
		else if (searchRecord.filesize<1000000000)
			sprintf(str1, "%11s %ldM\n", searchRecord.filename, searchRecord.filesize/(1024*1024) );
		}
	stdio_write(str1);
	while (!FindNext( &searchRecord ))
		{
		if (searchRecord.attributes&ATTR_DIRECTORY)
			sprintf(str1, "%11s -DIR-\n", searchRecord.filename);
	else
		{
		if (searchRecord.filesize<1000)
			sprintf(str1, "%11s %ldB\n", searchRecord.filename, searchRecord.filesize );
		else if (searchRecord.filesize<1000000)
			sprintf(str1, "%11s %ldK\n", searchRecord.filename, searchRecord.filesize/1024 );
		else if (searchRecord.filesize<1000000000)
			sprintf(str1, "%11s %ldM\n", searchRecord.filename, searchRecord.filesize/(1024*1024) );
		}
		stdio_write(str1);
		}
	FSchdir(path_old);
	return APP_RETVAL_OK;
	}
else
	{
	stdio_write("NO FILES\n");
	FSchdir(path_old);
	return APP_RETVAL_OK;
	}
}




unsigned char app_ad_start (unsigned char * args)
{
if (parse_cmdline (args)!=0)
	{
	return 1;
	}
return 0;
}

unsigned char app_ad_loop (unsigned char state)
{
unsigned char oneChar;
FSgetcwd(path_old, sizeof(path_old));
FSchdir(path1);
fp1= FSfopen (param1, "r");
if (fp1 == NULL)
	return APP_RETVAL_FOE;
while (!FSfeof( fp1 ))
	{
	if (FSfread( &oneChar, 1, 1, fp1) == 1)
		{
		if ((oneChar>=0x20)|(oneChar==NEW_LINE)) stdio_c( oneChar );
		}
	else
		{
		FSfclose( fp1 );
		FSchdir(path_old);
		return APP_RETVAL_FOE;
		}
	}
FSfclose( fp1 );
FSchdir(path_old);
stdio_c(NEW_LINE);
return APP_RETVAL_OK;
}

unsigned char app_cd_start (unsigned char * args)
{
if (parse_cmdline (args)==1)
	{
	return 1;
	}
return 0;
}

unsigned char app_cd_loop (unsigned char state)
{
if (param1[0]=='?')
	{
	FSgetcwd(param1, sizeof(param1));
	stdio_write(param1);
	stdio_c(NEW_LINE);
	return APP_RETVAL_OK;
	}
else
	{
	if (FSchdir(param1))
		{
		return APP_RETVAL_FOE;
		}
	return APP_RETVAL_OK;
	}
return APP_RETVAL_UE;
}

unsigned char app_cp_start (unsigned char * args)
{
if (parse_cmdline (args)==2)
	{
	return 1;
	}
return 0;
}

unsigned char app_cp_loop (unsigned char state)
{
unsigned char rbyt;
UINT16 totbyt;
FSgetcwd(path_old, sizeof(path_old));
FSchdir(path1);
fp1 = FSfopen( param1, "r"); 
if (fp1 == NULL)
	{
	return APP_RETVAL_FOE;
	}
//FSchdir("\\DIR1");
FSchdir(path_old);
FSchdir(path2);
fp2 = FSfopen( param2, "w"); 
if (fp2 == NULL)
	{
	FSfclose(fp1);
	FSchdir(path_old);
	return APP_RETVAL_FOE;
	}
totbyt = 0;
while (!FSfeof(fp1))
	{
	rbyt = FSfread( copy_buffer, 1, sizeof (copy_buffer),fp1);
	totbyt = totbyt + rbyt;
	if (rbyt>0)
		{
		if (FSfwrite( copy_buffer, 1, rbyt,fp2) != rbyt)
			{
			FSfclose(fp1);
			FSfclose(fp2);
			FSchdir(path_old);
			return APP_RETVAL_FWE;
			}
		stdio_c('.');
		}
	}	
stdio_c('|');
FSfclose(fp1);
FSfclose(fp2);
FSchdir(path_old);
return APP_RETVAL_OK;
}

void app_test(void)
{
}

unsigned char parse_cmdline (unsigned char * line)
{
unsigned char *pt1,*pt2,*pt3,len,params;
replace_str(line,'/','\\');
pt1 = line;
param1[0] = param2[0] = param3[0] = path1[0] = path2[0] = params = 0; 
if (!is_fnchar(*(pt1)))
	{
	while ((!is_fnchar(*pt1))&(*pt1!=0))
		*pt1++;
	}
if (*pt1==0) return 0;
pt2 = (unsigned char *)strpbrk(pt1," ");
if (pt2!=0)
	{
	params = 2;
	*pt2=0;
	brk_parpath(pt1,param1,path1);
	*pt2++;
	if (!is_fnchar(*(pt2)))
		{
		while ((!is_fnchar(*pt2))&(*pt2!=0))
			*pt2++;
		}
	pt1 = pt2;
	pt2 = (unsigned char *)strpbrk(pt1," ");
	if (pt2!=0)
		{
		params=3;
		*pt2=0;
		brk_parpath(pt1,param2,path2);
		*pt2++;
		if (!is_fnchar(*(pt2)))
			{
			while ((!is_fnchar(*pt2))&(*pt2!=0))
				*pt2++;
			}
		strcpy(param3,pt2);
		}
	else
		{
		brk_parpath(pt1,param2,path2);
		}
	}
else
	{
	brk_parpath(pt1,param1,path1);
	params = 1;
	}
string_upper(param1);
string_upper(param2);
string_upper(path1);
string_upper(path2);
string_upper(param3);
return params;
}

unsigned char is_fnchar (unsigned char dat)
{
if (isalpha(dat)|isdigit(dat)|(dat=='-')|(dat=='*')|(dat=='?')|(dat=='\\')|(dat=='.')|(dat=='/'))
	return 1;
else return 0;
}

unsigned char brk_parpath(unsigned char *input, unsigned char *param, unsigned char *path)
{
unsigned char * ptr,len;
strcpy( path,input);
ptr = (unsigned char *)strrchr(path,'\\');
if (ptr!=NULL)
	{
	strcpy(param,ptr+1);
	*(ptr+1)=0;
	}
else
	{
	strcpy(param,path);
	strcpy(path,".");
	}
}

unsigned char replace_str (unsigned char * str, unsigned char old, unsigned char new)
{
unsigned char count;
while (*str!=0)
	{
	if (*str==old)
		*str = new;
	*str++;
	}
}


unsigned char app_re_start (unsigned char * args)
{
if (parse_cmdline (args)==2)
	{
	return 1;
	}
return 0;
}

unsigned char app_re_loop (unsigned char state)
{
fp1 = FSfopen( param1, "r"); 
if (fp1 == NULL)
	{
	return APP_RETVAL_FOE;
	}
if (FSrename( param2, fp1 ))
	{
	return APP_RETVAL_FWE;
	}	
FSfclose(fp1);
return APP_RETVAL_OK;
}

unsigned char app_er_start (unsigned char * args)
{
if (parse_cmdline (args)==1)
	{
	return 1;
	}
return 0;
}

unsigned char app_er_loop (unsigned char state)
{
FSgetcwd(path_old, sizeof(path_old));
FSchdir(path1);
if (FindFirst( param1, ATTR_ARCHIVE | ATTR_READ_ONLY | ATTR_HIDDEN, &searchRecord ))
	{
	return APP_RETVAL_FOE;
	}
else
	{
	do
		{
		if (FSremove(searchRecord.filename))
			{
			return APP_RETVAL_FWE;
			FSchdir(path_old);
			}
		}
	while(!FindNext(&searchRecord));
	}
FSchdir(path_old);
return APP_RETVAL_OK;
}

unsigned char app_md_start (unsigned char * args)
{
if (parse_cmdline (args)==1)
	{
	return 1;
	}
return 0;
}

unsigned char app_md_loop (unsigned char state)
{
FSgetcwd(path_old, sizeof(path_old));
FSchdir(path1);
if (FSmkdir(param1))
	{
	return APP_RETVAL_FWE;
	}
FSchdir(path_old);
return APP_RETVAL_OK;
}

unsigned char app_rd_start (unsigned char * args)
{
if (parse_cmdline (args)==1)
	{
	return 1;
	}
return 0;
}

unsigned char app_rd_loop (unsigned char state)
{
FSgetcwd(path_old, sizeof(path_old));
FSchdir(path1);
if (FSrmdir(param1,TRUE))
	{
	return APP_RETVAL_FWE;
	}
FSchdir(path_old);
return APP_RETVAL_OK;
}

unsigned char app_editor_start (unsigned char * args)
{
clear_input_file();
clear_disp_buffer();
init_editor();
args_num = parse_cmdline (args);
return 1;
}

unsigned char app_editor_loop (unsigned char state)
{
if (state==0) 
	{
	if (args_num==1)
	{	
	strcpy(file_select,param1);
	fp1 = FSfopen( param1, "r"); 
	if (fp1 == NULL)
		{
		fp1 = FSfopen (param1, "w");
		if (fp1 != NULL)
			{
			FSfclose (fp1);
			file_len = 0;
			input_file[file_len] = NEW_LINE;
			input_file[file_len+1] = 0;
			}
		else
			{
			return APP_RETVAL_FOE;
			}
		}

	else
		{
		file_len = FSfread(input_file,1,sizeof(input_file),fp1);
		FSfclose (fp1);
		input_file[file_len] = NEW_LINE;
		input_file[file_len+1] = 0;
		}
	}	

	state = 10;
	}	
if (state==1) state = 10;
if (state==10)			//editor loop
	{
	editor_stat = editor_task();
	if (editor_stat==0) 
		{
		state = 0;
		clear_disp_buffer();
		}
	if (editor_stat==2) 
		{
		state = 11;
		clear_disp_buffer();
		}
	}
if (state==11)		//esc button
	{
	di();
	clear_disp_buffer();
	sprintf ((char *)disp_buffer+0,  "  Return       ");
	sprintf ((char *)disp_buffer+16, "  Escape       ");
	sprintf ((char *)disp_buffer+32, "  Save         ");
	sprintf ((char *)disp_buffer+48, "  Load         ");
	sprintf ((char *)disp_buffer+64, "  Clear buffer ");
	sprintf ((char *)disp_buffer+80, "  Transmit     ");
	sprintf ((char *)disp_buffer+96, "  Receive      ");
	sprintf ((char *)disp_buffer+112,"               ");
	disp_buffer[arrow_line*16] = '*';
	ei();
	delay_ms(40);
	if (keys_spec.dn)
		{
		arrow_line++;
		if (arrow_line>6) arrow_line = 0;
		keys_spec.dn = 0;
		}
	if (keys_spec.up)
		{
		if (arrow_line>0) arrow_line--;
			else arrow_line = 6;
		keys_spec.up = 0;
		}
	if (keys_spec.ent)
		{
		keys_spec.ent = 0;
		state=arrow_line+110;
		}
	}
if (state==110)			//esc - return
	{
	state = 10;
	}	
if (state==111)			//esc - escape
	{
	arrow_line = 0;
	return APP_RETVAL_OK;
	}	
if (state==112)
	{
	if (save_file_dialog(file_select)==1)
		{
		if (file_select[0]!=0)
			{									//if file selected
			file_gen = FSfopen (file_select, "r");	//does it exist?
			if (file_gen != NULL)					//if yes, ask
				{
				FSfclose (file_gen);
				state=121;
				keys_spec.CHAR = 0;				//clear flags for sure
				}
			else								//if not, write
			state=120;
			}
		else
			{									//cancel saving
			state=10;
			}
		}
	}
if (state==113)
	{
	if (open_file_dialog(file_select)==1)
		{
		if (file_select[0]!=0)
			{
			file_gen = FSfopen (file_select, "r");
			if (file_gen != NULL)
				{
				file_len = FSfread(input_file,1,sizeof(input_file),file_gen);
				FSfclose (file_gen);
				input_file[file_len] = NEW_LINE;
				input_file[file_len+1] = 0;
				state=1;
				}
			else	
				state=1;
			}
		else
			{
			state=10;
			}
		}
	}

if (state==114)			//esc - clear
	{
	clear_input_file();
	state = 10;
	}	
if (state==120)
	{
	file_gen = FSfopen (file_select, "w");
	if (file_gen != NULL)
		{
		FSfwrite(input_file,1,file_len,file_gen);
		FSfclose (file_gen);
		state=125;
		}
	else	
		state=1;
	}
if (state==121)
	{
	sprintf ((char *)disp_buffer+48, "File exists");
	sprintf ((char *)disp_buffer+64, "OK-overwrite");
	sprintf ((char *)disp_buffer+80, "Esc-select new");
	if (keys_spec.ent)
		{
		keys_spec.ent = 0;	
		state=120;
		}
	if (keys_spec.esc)
		{
		keys_spec.esc = 0;	
		state=112;
		}				
	}	
if (state==125)
	{
	sprintf ((char *)disp_buffer+96, "File saved");	
	gen_dly = get_timer();
	state=126;		
	}
if (state==126)
	{
	if ((get_timer() - gen_dly)>500)
		state = 1;
	}
return state;
}


unsigned char app_as_start (unsigned char * args)
{
if (parse_cmdline (args)==2)
	{
	return 1;
	}
return 0;
//global_state = 20;
}


unsigned char write_output (UINT16 addr,UINT16 output, unsigned char * line, UINT16 linum)
{
if (addr<OUTPUT_SIZE)
	{
	output_file[addr] = output;
	debug_file[addr] = linum;
	}
return 0;
}


unsigned char c_get_line (UINT16 * position, unsigned char * output)
{
unsigned char rbyt,data,len,len2;
UINT16 pos;
char str1[32];
char * ptr;
pos = *position;
len = 0;
if (fp1 == NULL)
	{
	FSchdir(path_old);
	FSfclose(fp1);
	return APP_RETVAL_FOE;
	}
if (FSfseek(fp1,pos,SEEK_SET)!=0)
	{
	FSchdir(path_old);
	FSfclose(fp1);
	return APP_RETVAL_FOE;	
	}
len = FSfread( str1, 1, sizeof(str1), fp1);
if (len >0)
	{
	ptr = str1;
	while (*ptr>0x1F)
		{
		if (*ptr==0) return 0;
		*ptr++;
		}
	len  = ptr - str1;
	strncpy(output,str1,len);
	while (*ptr<0x1F)
		{
		if (*ptr==0) return 0;
		*ptr++;
		}
	len2  = ptr - str1;
	}
else
	{
	FSchdir(path_old);
	FSfclose(fp1);
	return APP_RETVAL_FOE;	
	}	
pos = pos + len2;
output[len] = 0x00;
*position = pos;
return len;

}


unsigned char app_as_loop (unsigned char state)
{
char str1[30];
if (state==0) 
	{
	stdio_write("Assembler...");
	FSgetcwd(path_old, sizeof(path_old));
	FSchdir(path1);
	fp1 = FSfopen( param1, "r"); 
	if (fp1 == NULL)
		{
		return APP_RETVAL_FOE;
		}
	//FSchdir("\\DIR1");
	FSchdir(path_old);
	FSchdir(path2);
	fp2 = FSfopen( param2, "w"); 
	if (fp2 == NULL)
		{
		FSfclose(fp2);
		FSchdir(path_old);
		return APP_RETVAL_FWE;
		}
//	FSfclose(fp2);
//	FSchdir(path_old);
	state = 20;
	}	
if (state==20)			//assembler run
	{
	di();
	#if defined (COMPILER)
	eee = compiler_run();
	#endif
	if (device.type == P18F)
		{
		cfg_bits[0]=0x0800;
		cfg_bits[1]=0x0000;
		cfg_bits[2]=0x8000;
		cfg_bits[3]=0x0085;
		}
	if (device.type == P18FJ)
		{
		cfg_bits[0]=0xFF8F;
		cfg_bits[1]=0xFF04;
		cfg_bits[2]=0xFFFF;
		}
	if (device.type == P18FK)
		{
		cfg_bits[0]=0x0800;
		cfg_bits[1]=0x0000;
		cfg_bits[2]=0x8000;
		cfg_bits[3]=0x0085;
		}		
	ei();
	keys_spec.ent=0;
	if (eee==0)
		{
		stdio_c(NEW_LINE);
		stdio_write("No errors");
		stdio_c(NEW_LINE);
		sprintf (str1, "On %d lines",assembled_lines);
		stdio_write(str1);
		stdio_c(NEW_LINE);
		}
	else
		{
		#if defined PRINT
		stdio_c(NEW_LINE);
		sprintf (str1, "Err %d",eee);
		stdio_write(str1);
		stdio_c(NEW_LINE);
		sprintf (str1, "Line: %d",line);
		stdio_write(str1);
		stdio_c(NEW_LINE);
		if (eee==1) sprintf (str1, "Unknown opcode  ");
		if (eee==2) sprintf (str1, "Bad p1          ");
		if (eee==3) sprintf (str1, "Bad p2          ");
		if (eee==4) sprintf (str1, "Bad p3          ");
		if (eee==5) sprintf (str1, "8 bit over range");
		if (eee==6) sprintf (str1, "11bit over range");
		if (eee==7) sprintf (str1, "Deftable over   ");
		if (eee==8) sprintf (str1, "Unknown def.    ");
		stdio_write(str1);
		stdio_c(NEW_LINE);
		#endif
		}
	state = 21;
	}
	if (state==21)			//assembler wait
	{
	//now we have config bits, device config, binary output and debug output here
	FSfclose(fp1);
	if (file_cbf_save(fp2,device,cfg_bits,4096,output_file,debug_file)==1)
		stdio_write("out saved");
	else
		stdio_write("out failed");
	stdio_c(NEW_LINE);
	FSfclose(fp2);
/*
	fp2 = FSfopen( "TST.OUT", "r"); 
	if (file_cbf_load(fp2,&device,cfg_bits,4096,output_file,debug_file)==1)
		stdio_write("File loaded");
	else
		stdio_write("File load failed");	
	FSfclose(fp2);

	fp2 = FSfopen( "TST2.OUT", "w"); 
	if (file_cbf_save(fp2,device,cfg_bits,4096,output_file,debug_file)==1)
		stdio_write("File saved");
	else
		stdio_write("File save failed");
	FSfclose(fp2);
*/
	FSchdir(path_old);
	return APP_RETVAL_OK;
	}
}

unsigned char file_cbf_save (FSFILE *file, DEVICE dev, UINT16 * cfg, UINT16 len, UINT16 * out, UINT16 * deb)
{
UINT16 dev_16[10];
dev_16[0] = dev.type;
dev_16[1] = dev.eblock;
dev_16[2] = dev.wblock;
dev_16[3] = dev.flash_write;
dev_16[4] = dev.flash_erase;
dev_16[5] = dev.flash_size;
dev_16[6] = dev.ram_hb;
dev_16[7] = dev.debug_clock;
dev_16[8] = 0;
dev_16[9] = 0;
if (FSfwrite("~cbf",1,4,file)!=4) return 0;
if (FSfwrite(cfg,2,8,file)!=8) return 0;
if (FSfwrite(dev_16,2,10,file)!=10) return 0;
dev_16[0] = len;
if (FSfwrite(dev_16,2,1,file)!=1) return 0;
if (FSfwrite(out,2,len,file)!=len) return 0;
if (FSfwrite(deb,2,len,file)!=len) return 0;
return 1;
}

unsigned char file_cbf_load (FSFILE *file, DEVICE * dev, UINT16 * cfg, UINT16 len, UINT16 * out, UINT16 * deb)
{
UINT16 dev_16[10];
UINT8 test[6];
UINT16 len_a[2];
if (FSfseek(file,0,SEEK_SET)!=0) return 0;
if (FSfread(test,1,4,file)!=4) return 0;
if (strncmp(test,"~cbf",4)!=0) return 2;
if (FSfread(cfg,2,8,file)!=8) return 0;
if (FSfread(dev_16,2,10,file)!=10) return 0;
if (FSfread(len_a,2,1,file)!=1) return 0;
len = len_a[0];
if (FSfread(out,2,len,file)!=len) return 0;
if (FSfread(deb,2,len,file)!=len) return 0;

dev->type = 		dev_16[0];
dev->eblock = 		dev_16[1];
dev->wblock = 		dev_16[2];
dev->flash_write = 	dev_16[3];
dev->flash_erase = 	dev_16[4];
dev->flash_size = 	dev_16[5];
dev->ram_hb = 		dev_16[6];
dev->debug_clock = 	dev_16[7];
return 1;

}


unsigned char app_pg_start (unsigned char * args)
{
if (parse_cmdline (args)==1)
	{
	return 1;
	}
return 0;
}

unsigned char app_pg_loop (unsigned char state)
{
UINT16 ppp,verify_result;
char str1[20];
if (state==0)
	{
	stdio_write("Programmer...");
	stdio_c(NEW_LINE);
	FSgetcwd(path_old, sizeof(path_old));
	FSchdir(path1);
	fp1 = FSfopen( param1, "r"); 
	if (fp1 == NULL)
		{
		return APP_RETVAL_FOE;
		}
	if (file_cbf_load(fp1,&device,cfg_bits,4096,output_file,debug_file)==1)
		stdio_write("File loaded");
	else
		stdio_write("File load failed");
	stdio_c(NEW_LINE);
	FSfclose(fp1);
	state = 3;
	}	

if (state==3)
	{
	prog_enter_icsp(device);
	prog_enter_icsp(device);		
	#if defined PRINT
	delay_ms(10);
	ppp = prog_get_devid(device);
	clear_disp_buffer();
	sprintf (str1, "DEVID: 0x%04X",ppp);
	stdio_write(str1);
	stdio_c(NEW_LINE);
	sprintf (str1, "Erasing FLASH");
	stdio_write(str1);
	stdio_c(NEW_LINE);
	#endif
	prog_erase_flash(device);
	state = 30;
	}
if (state==30)
	{
	ppp = prog_get_devid(device);
	#if defined PRINT
	sprintf (str1, "Writing FLASH");
	stdio_write(str1);
	stdio_c(NEW_LINE);
	#endif
	di();
	prog_write_flash(device);
	ei();
	state = 31;
	}
if (state==31)
	{
	ppp = prog_get_devid(device);
	#if defined PRINT
	sprintf (str1, "Config bits");
	stdio_write(str1);
	stdio_c(NEW_LINE);
	#endif
	prog_write_cfgs(device);
	
	state = 32;
	}
if (state==32)
	{

	sprintf (str1, "Verify");
	stdio_write(str1);
	stdio_c(NEW_LINE);

	verify_result = prog_verify_flash(device);
	if (verify_result==0xFFFF)
		sprintf (str1, "Done");
	else 
		sprintf (str1, "Error at %d",verify_result);
	stdio_write(str1);
	stdio_c(NEW_LINE);		
	prog_leave_icsp(device);
	state = 39;
	}
if (state==39)
	{
	return APP_RETVAL_OK;
	}
}


#define MEMSIZE 	30000
#define STACKSIZE 	5000
#define CODESIZE 	30000
#define	INPUTSIZE	5000

#define	RET_OK			0
#define	RET_PTR_OVF		1
#define	RET_PTR_UNF		2
#define	RET_STK_OVF		3
#define	RET_STK_UNF		4
#define	RET_INP_END		5
char *bfcode, *tape, *testx, *bf_input;
int *stack;
int bf_pointer,bf_stack_p,bf_i,inp_pointer,inp_size;


unsigned char app_bf_start (unsigned char * args)
{
unsigned char args_num;
args_num = parse_cmdline (args);
if ((args_num==1)|(args_num==2))
	{
	return 1;
	}
return 0;
}

unsigned char app_bf_loop (unsigned char state)
{
unsigned char retval;
if (state==0)
	{
	inp_pointer = 0;
//	stdio_write("BF\n");
	FSgetcwd(path_old, sizeof(path_old));
	FSchdir(path1);
	fp1 = FSfopen( param1, "r"); 
	if (fp1 == NULL)
		{
		return APP_RETVAL_FOE;
		}
	bfcode = calloc(CODESIZE,sizeof (char));
	if (bfcode!=0)
		{
		if (FSfread(bfcode,1,CODESIZE,fp1)==0) 
			{
			FSfclose(fp1);
			free(bfcode);
			return  APP_RETVAL_FOE;
			}		
		}
	FSfclose(fp1);
	FSchdir(path_old);
	bf_input = calloc(INPUTSIZE,sizeof (char));
	if (strlen(param2)!=0)
		{
		FSchdir(path2);
		fp1 = FSfopen( param2, "r"); 
		if (fp1 == NULL)
			{
			free(bfcode);
			free(bf_input);
			return APP_RETVAL_FOE;
			}
		if (bf_input!=0)
			{
			inp_size = FSfread(bf_input,1,INPUTSIZE,fp1);
			if (bf_input==0) 
				{
				FSfclose(fp1);
				free(bfcode);
				free(bf_input);
				return  APP_RETVAL_FOE;
				}		
			}
		FSfclose(fp1);
		}
	FSchdir(path_old);
	
	if (bf_input==0)
		{
		if (bfcode!=0)	free(bfcode);
		return APP_RETVAL_MEM;
		}	
	if (bfcode==0)
		{
		if (bf_input!=0) free(bf_input);
		return APP_RETVAL_MEM;
		}
	state = 1;
	}	
if (state==1)
	{
	char retval;
	stack = calloc(STACKSIZE,sizeof (int));
	if (stack!=NULL)
		{
		tape = calloc(MEMSIZE,sizeof (char));
		if (tape!=NULL) 
			{
			return 2;
			}
		free(stack);		
		}
	free(bfcode);
	free(bf_input);
	return APP_RETVAL_MEM;
	}
if (state==2)
	{
	retval = do_bf(bfcode);
	if (retval!=0)
		{
		switch (retval)
			{
			case RET_PTR_OVF: stdio_write("\nBF-tape pointer overflow\n"); break;
			case RET_PTR_UNF: stdio_write("\nBF-tape pointer underflow\n"); break;
			case RET_STK_OVF: stdio_write("\nBF-stack pointer overflow\n"); break;
			case RET_STK_UNF: stdio_write("\nBF-stack pointer underflow\n"); break;
			case RET_INP_END: stdio_write("\nBF-input ended\n"); break;
			}
		}
	state = 3;
	}
if (state==3)
	{
	free(bfcode);
	free(tape);
	free(stack);
	free(bf_input);
	stdio_write("\n");
	return APP_RETVAL_OK;
	}

return state;	
}

unsigned char do_bf (unsigned char * code)
{
bf_stack_p = -1;
bf_i=0;
while (1) 
	{
	switch(code[bf_i++]) 	
		{
		case '>': bf_pointer++; if(bf_pointer>=MEMSIZE) return RET_PTR_OVF; break;
		case '<': bf_pointer--; if(bf_pointer<0) return RET_PTR_UNF; break;
		case '+': tape[bf_pointer]++; break;
		case '-': tape[bf_pointer]--; break;
		case '[': bf_stack_p++; if(bf_stack_p>=STACKSIZE) return RET_STK_OVF; stack[bf_stack_p] = bf_i; break;
		case ']': if(tape[bf_pointer] != 0) { bf_i = stack[bf_stack_p]-1; } bf_stack_p--; if(bf_stack_p<-1) return RET_STK_UNF; break;
		case '.': stdio_c(tape[bf_pointer]); break;
		case ',': if (inp_pointer < inp_size) {tape[bf_pointer] = bf_input[inp_pointer++];} else return RET_INP_END; break;
		case 0x00: return RET_OK; break;
		}
	}
}


unsigned char app_ba_start (unsigned char * args)
{
if (parse_cmdline (args)==1)
	{
	return 1;
	}
return 0;
}

unsigned char app_ba_loop (unsigned char state)
{
if (state==0)
	{
//	stdio_write("BASIC\n");
	FSgetcwd(path_old, sizeof(path_old));
	FSchdir(path1);
	fp1 = FSfopen( param1, "r"); 
	if (fp1 == NULL)
		{
		return APP_RETVAL_FOE;
		}
	bprog = malloc(40000);	
	if (bprog!=0)
		{
		if (FSfread(bprog,1,40000,fp1)==0) 
			{
			FSfclose(fp1);
			return  APP_RETVAL_FOE;
			}
		ubasic_init(bprog);
	 	} 
	stdio_c(NEW_LINE);
	FSfclose(fp1);
	FSchdir(path_old);
	state = 1;
	}	
if (state==1)
	{
	ubasic_run();
 	if (ubasic_finished()==1)
 		state = 2;
	}
if (state==2)
	{
	free(bprog);
	return APP_RETVAL_OK;
	}
return state;	
}

unsigned char app_te_start (unsigned char * args)
{
if (parse_cmdline (args)==1)
	{
	return 1;
	}
return 0;
}


unsigned char app_te_loop (unsigned char state)
{
		if (strcmp(param1,"local")==0) stdio_src = STDIO_LOCAL;
else	if (strcmp(param1,"0")==0) stdio_src = STDIO_LOCAL;
else	if (strcmp(param1,"tty1")==0) stdio_src = STDIO_TTY1;
else	if (strcmp(param1,"1")==0) stdio_src = STDIO_TTY1;
else	stdio_write("sel err\n");
return APP_RETVAL_OK;	
}

unsigned char app_t0_start (unsigned char * args)
{
return 1;
}


unsigned char app_t0_loop (unsigned char state)
{
stdio_src = STDIO_LOCAL;
return APP_RETVAL_OK;	
}


