//#include "stdafx.h"
#include "compiler_low_level.h"
#include "compiler.h"
#include "string.h"
#include "stdlib.h"
#include "stdio.h"
#include "substitute.h"
#include "ctype.h"
#include "config.h"

unsigned char f,d,a,opcodes,b,err;
unsigned char str1[10],str2[10],str3[10];
UINT16 opcode0,opcode1,fs,fd,address,n;
extern UINT16 cfg_bits[8];
extern DEVICE	device;


#if defined (COMPILER)



unsigned char take_params_fda (unsigned char * string, unsigned char actual);
unsigned char take_params_fa (unsigned char * string, unsigned char actual);
unsigned char take_params_fba (unsigned char * string, unsigned char actual);
unsigned char take_params_n (unsigned char * string, unsigned char actual);
unsigned char convert_to_8_number (unsigned char * string);
UINT16 modify_fda_opcode (UINT16 opcode);
UINT16 modify_fa_opcode (UINT16 opcode);
UINT16 modify_fba_opcode (UINT16 opcode);
unsigned char is_delimiter(unsigned char chr);


// Converts a hexadecimal string to integer
char xtoi_j(const char* xs, UINT16* result)
{
 char szlen = strlen(xs);
 int xv, fact;
 char i;

 if (szlen > 0)
 {
  // Converting more than 32bit hexadecimal value?
  if (szlen>8) return 2; // exit

  // Begin conversion here
  *result = 0;
  fact = 1;

  // Run until no more character to convert
  for(i=szlen-1; i>=0 ;i--)
  {
   if (isxdigit(*(xs+i)))
   {
    if (*(xs+i)>=97)
    {
     xv = ( *(xs+i) - 97) + 10;
    }
    else if ( *(xs+i) >= 65)
    {
     xv = (*(xs+i) - 65) + 10;
    }
    else
    {
     xv = *(xs+i) - 48;
    }
    *result += (xv * fact);
    fact *= 16;
   }
   else
   {
    // Conversion was abnormally terminated
    // by non hexadecimal digit, hence
    // returning only the converted with
    // an error value 4 (illegal hex character)
    return 4;
   }
  }
 }

 // Nothing to convert
 return 1;
}

void set_opcodes (unsigned char o)
{
opcodes = o;
}

unsigned char get_opcodes (void)
{
return opcodes;
}
UINT16 get_opcode0 (void)
{
return opcode0;
}
UINT16 get_opcode1 (void)
{
return opcode1;
}

UINT16 get_addr (void)
{
return address;
}

unsigned char find_next_substring (unsigned char * string, unsigned char actual)
{
unsigned char len,pos;
len = strlen((char*)string);
pos = actual;
while (is_delimiter(string[actual])==1)
{
	if (actual<len)
	{
		actual++;
	}
	else return 255;
}
return actual;
}

unsigned char is_delimiter(unsigned char chr)
{
//if (chr<('.'-1)) return 1;
if ((chr<'!')|(chr==',')|(chr=='.')) return 1;
else return 0;
}

unsigned char get_next_token (unsigned char * source, unsigned char *dest, unsigned char actual)
{
unsigned char len,pos,i;
len = strlen((char*)source);
pos = actual;
i=0;
while (is_delimiter(source[pos])==1)
{
	if (pos<len)
	{
		pos++;
	}
	else return 255;
}

while (is_delimiter(source[pos])==0)
{
	if (pos<len)
	{
		dest[i] = source[pos];
		i++;
		pos++;
	}
	else return 255;
}
dest[i] = 0;
return pos;
}

unsigned char is_number (unsigned char num)
{
if ((num>('0'-1)) & (num<('9'+1))) return 1;
else return 0;
}

unsigned char convert_to_8_number (unsigned char * string)
{
unsigned char str_len,j,num;
UINT16 numi;
str_len = strlen((char *)string);
num=0;
j=0;
if (str_len>0)
{
	if ((string[0]=='0')&(string[1]=='x'))
			{
			if (xtoi_j((char *) string,&numi))
				return ((unsigned char) numi);
			else return 0;
			}
	else num = atoi((char *) string);
	}
return num;
}

UINT16 convert_to_16_number (unsigned char * string)
{
unsigned char str_len,j;
UINT16 num;
str_len = strlen((char *)string);
num=0;
j=0;
if (str_len>0)
{
	if ((string[0]=='0')&(string[1]=='x'))
			{
			if (xtoi_j((char *) string,&num))
				return ( num);
			else return 0;
			}
	else num = atoi((char *) string);
	}
return num;
}


unsigned char take_params_fda (unsigned char * string, unsigned char actual)
{
unsigned char str_len;
str_len = strlen((char *)string);

str1[0]=0;
str2[0]=0;
str3[0]=0;
actual = get_next_token((unsigned char *)string, (unsigned char*)str1,actual);
actual = get_next_token((unsigned char *)string, (unsigned char*)str2,actual);
actual = get_next_token((unsigned char *)string, (unsigned char*)str3,actual);
f = F_DEFAULT;
d = D_DEFAULT;
a = A_DEFAULT;
if (strlen((char *)str1)>0) f = convert_to_8_number((unsigned char *)str1);
if (strlen((char *)str2)>0) d = convert_to_8_number((unsigned char *)str2);
if (strlen((char *)str3)>0) a = convert_to_8_number((unsigned char *)str3);
if (d>1) return E_BAD_P2;
if (a>1) return E_BAD_P3;
opcodes = 1;
return E_OK;
}

unsigned char take_params_fa (unsigned char * string, unsigned char actual)
{
unsigned char str_len;
str_len = strlen((char *)string);

str1[0]=0;
str2[0]=0;
actual = get_next_token((unsigned char *)string, (unsigned char*)str1,actual);
actual = get_next_token((unsigned char *)string, (unsigned char*)str2,actual);
f = F_DEFAULT;
a = A_DEFAULT;
if (strlen((char *)str1)>0) f = convert_to_8_number((unsigned char *)str1);
if (strlen((char *)str2)>0) a = convert_to_8_number((unsigned char *)str2);
if (a>1) return E_BAD_P2;
opcodes = 1;
return E_OK;
}

unsigned char take_params_fsfd (unsigned char * string, unsigned char actual)
{
unsigned char str_len;
str_len = strlen((char *)string);

str1[0]=0;
str2[0]=0;
actual = get_next_token((unsigned char *)string, (unsigned char*)str1,actual);
actual = get_next_token((unsigned char *)string, (unsigned char*)str2,actual);
fs = F_DEFAULT;
fd = A_DEFAULT;
if (strlen((char *)str1)>0) fs = convert_to_16_number((unsigned char *)str1);
if (strlen((char *)str2)>0) fd = convert_to_16_number((unsigned char *)str2);
opcodes = 2;
return E_OK;
}

unsigned char take_params_fba (unsigned char * string, unsigned char actual)
{
unsigned char str_len;
str_len = strlen((char *)string);

str1[0]=0;
str2[0]=0;
str3[0]=0;
actual = get_next_token((unsigned char *)string, (unsigned char*)str1,actual);
actual = get_next_token((unsigned char *)string, (unsigned char*)str2,actual);
actual = get_next_token((unsigned char *)string, (unsigned char*)str3,actual);
f = F_DEFAULT;
b = B_DEFAULT;
a = A_DEFAULT;
if (strlen((char *)str1)>0) f = convert_to_8_number((unsigned char *)str1);
if (strlen((char *)str2)>0) b = convert_to_8_number((unsigned char *)str2);
if (strlen((char *)str3)>0) a = convert_to_8_number((unsigned char *)str3);
if (b>7) return E_BAD_P2;
if (a>1) return E_BAD_P3;
opcodes = 1;
return E_OK;
}

unsigned char take_params_n (unsigned char * string, unsigned char actual)
{
unsigned char str_len;
str_len = strlen((char *)string);

str1[0]=0;
actual = get_next_token((unsigned char *)string, (unsigned char*)str1,actual);
n = 0;
if (strlen((char *)str1)>0) n = convert_to_16_number((unsigned char *)str1);
opcodes = 1;
return E_OK;
}


UINT16 modify_fda_opcode (UINT16 opcode)
{
if (strlen((char *)str1)>0) opcode = opcode | f;
if (strlen((char *)str2)>0)
	{
	if (d==1) opcode = opcode | 0x0200;
	}
if (strlen((char *)str3)>0)
	{
	if (a==1) opcode = opcode | 0x0100;
	}
return opcode;
}

UINT16 modify_fa_opcode (UINT16 opcode)
{
if (strlen((char *)str1)>0) opcode = opcode | f;
if (strlen((char *)str2)>0)
	{
	if (a==1) opcode = opcode | 0x0100;
	}
return opcode;
}

UINT16 modify_fba_opcode (UINT16 opcode)
{
if (strlen((char *)str1)>0) opcode = opcode | f;
if (strlen((char *)str2)>0)
	{
	opcode = opcode | (((UINT16)b)<<9);
	}
if (strlen((char *)str3)>0)
	{
	if (a==1) opcode = opcode | 0x0100;
	}
return opcode;
}

UINT16 modify_n_opcode (UINT16 opcode)
{
if (strlen((char *)str1)>0) opcode = opcode | (n&0x00FF);
return opcode;
}

//fda group
unsigned char op_addwf(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x2400);
return err;
}

unsigned char op_addwfc(unsigned char * string, unsigned char actual)
{
take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x2000);
return E_OK;
}
unsigned char op_andwf(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x1400);
return err;
}
unsigned char op_comf(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x1C00);
return err;
}
unsigned char op_decf(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x0400);
return err;
}
unsigned char op_decfsz(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x2C00);
return err;
}
unsigned char op_dcfsnz(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x4C00);
return err;
}
unsigned char op_incf(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x2800);
return err;
}
unsigned char op_incfsz(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x3C00);
return err;
}
unsigned char op_infsnz(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x4800);
return err;
}
unsigned char op_iorwf(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x1000);
return err;
}
unsigned char op_movf(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x5000);
return err;
}

unsigned char op_rlcf(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x3400);
return err;
}

unsigned char op_rlncf(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x4400);
return err;
}

unsigned char op_rrcf(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x3000);
return err;
}

unsigned char op_rrncf(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x4000);
return err;
}

unsigned char op_subfwb(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x5400);
return err;
}

unsigned char op_subwf(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x5C00);
return err;
}

unsigned char op_subwfb(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x5800);
return err;
}
unsigned char op_swapf(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x3800);
return err;
}
unsigned char op_xorwf(unsigned char * string, unsigned char actual)
{
err = take_params_fda((unsigned char *)string,actual);
opcode0 = modify_fda_opcode(0x1800);
return err;
}

//fa group
unsigned char op_clrf(unsigned char * string, unsigned char actual)
{
err = take_params_fa((unsigned char *)string,actual);
opcode0 = modify_fa_opcode(0x6A00);
return err;
}

unsigned char op_cpfseq(unsigned char * string, unsigned char actual)
{
err = take_params_fa((unsigned char *)string,actual);
opcode0 = modify_fa_opcode(0x6200);
return err;
}
unsigned char op_cpfsgt(unsigned char * string, unsigned char actual)
{
err = take_params_fa((unsigned char *)string,actual);
opcode0 = modify_fa_opcode(0x6400);
return err;
}
unsigned char op_cpfslt(unsigned char * string, unsigned char actual)
{
err = take_params_fa((unsigned char *)string,actual);
opcode0 = modify_fa_opcode(0x6000);
return err;
}
unsigned char op_movwf(unsigned char * string, unsigned char actual)
{
err = take_params_fa((unsigned char *)string,actual);
opcode0 = modify_fa_opcode(0x6E00);
return err;
}
unsigned char op_mulwf(unsigned char * string, unsigned char actual)
{
err = take_params_fa((unsigned char *)string,actual);
opcode0 = modify_fa_opcode(0x0200);
return err;
}
unsigned char op_negf(unsigned char * string, unsigned char actual)
{
err = take_params_fa((unsigned char *)string,actual);
opcode0 = modify_fa_opcode(0x6C00);
return err;
}
unsigned char op_setf(unsigned char * string, unsigned char actual)
{
err = take_params_fa((unsigned char *)string,actual);
opcode0 = modify_fa_opcode(0x6800);
return err;
}
unsigned char op_tstfsz(unsigned char * string, unsigned char actual)
{
err = take_params_fa((unsigned char *)string,actual);
opcode0 = modify_fa_opcode(0x6600);
return err;
}

//movff
unsigned char op_movff(unsigned char * string, unsigned char actual)
{
take_params_fsfd((unsigned char *)string,actual);
opcode0 = 0xC000;
opcode1 = 0xF000;
if (fs>4096) return E_BAD_P1;
if (fd>4096) return E_BAD_P2;
opcode0 = opcode0 | fs;
opcode1 = opcode1 | fd;
opcodes = 2;
return E_OK;
}


unsigned char op_bcf(unsigned char * string, unsigned char actual)
{
err = take_params_fba((unsigned char *)string,actual);
opcode0 = modify_fba_opcode(0x9000);
return err;
}

unsigned char op_bsf(unsigned char * string, unsigned char actual)
{
err = take_params_fba((unsigned char *)string,actual);
opcode0 = modify_fba_opcode(0x8000);
return err;
}

unsigned char op_btfsc(unsigned char * string, unsigned char actual)
{
err = take_params_fba((unsigned char *)string,actual);
opcode0 = modify_fba_opcode(0xB000);
return err;
}

unsigned char op_btfss(unsigned char * string, unsigned char actual)
{
err = take_params_fba((unsigned char *)string,actual);
opcode0 = modify_fba_opcode(0xA000);
return err;
}

unsigned char op_btg(unsigned char * string, unsigned char actual)
{
err = take_params_fba((unsigned char *)string,actual);
opcode0 = modify_fba_opcode(0x7000);
return err;
}

unsigned char op_bc(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced)
{
take_params_n((unsigned char *)string,actual);
if (replaced>0) n=n-address-1;
fs = n;
if (n&0x8000) fs=~n;
if ((fs&0x0000FF00)!=0) return E_8B_OUT;
opcode0 = modify_n_opcode(0xE200);
return E_OK;
}

unsigned char op_bn(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced)
{
take_params_n((unsigned char *)string,actual);
if (replaced>0) n=n-address-1;
fs = n;
if (n&0x8000) fs=~n;
if ((fs&0x0000FF00)!=0) return E_8B_OUT;
opcode0 = modify_n_opcode(0xE600);
return E_OK;
}

unsigned char op_bnc(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced)
{
take_params_n((unsigned char *)string,actual);
if (replaced>0) n=n-address-1;
fs = n;
if (n&0x8000) fs=~n;
if ((fs&0x0000FF00)!=0) return E_8B_OUT;
opcode0 = modify_n_opcode(0xE300);
return E_OK;
}

unsigned char op_bnn(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced)
{
take_params_n((unsigned char *)string,actual);
if (replaced>0) n=n-address-1;
fs = n;
if (n&0x8000) fs=~n;
if ((fs&0x0000FF00)!=0) return E_8B_OUT;
opcode0 = modify_n_opcode(0xE700);
return E_OK;
}

unsigned char op_bz(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced)
{
take_params_n((unsigned char *)string,actual);
if (replaced>0) n=n-address-1;
fs = n;
if (n&0x8000) fs=~n;
if ((fs&0x0000FF00)!=0) return E_8B_OUT;
opcode0 = modify_n_opcode(0xE000);
return E_OK;
}

unsigned char op_bov(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced)
{
take_params_n((unsigned char *)string,actual);
if (replaced>0) n=n-address-1;
fs = n;
if (n&0x8000) fs=~n;
if ((fs&0x0000FF00)!=0) return E_8B_OUT;
opcode0 = modify_n_opcode(0xE400);
return E_OK;
}

unsigned char op_bnz(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced)
{
take_params_n((unsigned char *)string,actual);
if (replaced>0) n=n-address-1;
fs = n;
if (n&0x8000) fs=~n;
if ((fs&0x0000FF00)!=0) return E_8B_OUT;
opcode0 = modify_n_opcode(0xE100);
return E_OK;
}

unsigned char op_bnov(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced)
{
take_params_n((unsigned char *)string,actual);
if (replaced>0) n=n-address-1;
fs = n;
if (n&0x8000) fs=~n;
if ((fs&0x0000FF00)!=0) return E_8B_OUT;
opcode0 = modify_n_opcode(0xE500);
return E_OK;
}

unsigned char op_bra(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced)
{
take_params_n((unsigned char *)string,actual);
if (replaced>0) n=n-address-1;
fs = n;
if (n&0x8000) fs=~n;
if ((fs&0x0000F800)!=0) return E_11B_OUT;
opcode0 = 0xD000 | (n&0x07FF);
return E_OK;
}

unsigned char op_rcall(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced)
{
take_params_n((unsigned char *)string,actual);
if (replaced>0) n=n-address-1;
fs = n;
if (n&0x8000) fs=~n;
if ((fs&0x0000F800)!=0) return E_11B_OUT;
opcode0 = 0xD800 | (n&0x07FF);
return E_OK;
}

unsigned char op_call(unsigned char * string, unsigned char actual)
{
take_params_n((unsigned char *)string,actual);
//n=n/2;
opcode0 = 0xEC00 | (n&0x00FF);
opcode1 = 0xF000 | ((n>>8)&0x00FF);
opcodes = 2;
return E_OK;
}

unsigned char op_goto(unsigned char * string, unsigned char actual)
{
take_params_n((unsigned char *)string,actual);
//n=n/2;
opcode0 = 0xEF00 | (n&0x00FF);
opcode1 = 0xF000 | ((n>>8)&0x00FF);
opcodes = 2;
return E_OK;
}


unsigned char op_retlw(unsigned char * string, unsigned char actual)
{
take_params_n((unsigned char *)string,actual);
opcode0 = modify_n_opcode(0x0C00);
return E_OK;
}

unsigned char op_addlw(unsigned char * string, unsigned char actual)
{
take_params_n((unsigned char *)string,actual);
opcode0 = modify_n_opcode(0x0F00);
return E_OK;
}
unsigned char op_andlw(unsigned char * string, unsigned char actual)
{
take_params_n((unsigned char *)string,actual);
opcode0 = modify_n_opcode(0x0B00);
return E_OK;
}
unsigned char op_iorlw(unsigned char * string, unsigned char actual)
{
take_params_n((unsigned char *)string,actual);
opcode0 = modify_n_opcode(0x0900);
return E_OK;
}
unsigned char op_movlb(unsigned char * string, unsigned char actual)
{
take_params_n((unsigned char *)string,actual);
opcode0 = modify_n_opcode(0x0100);
return E_OK;
}
unsigned char op_movlw(unsigned char * string, unsigned char actual)
{
take_params_n((unsigned char *)string,actual);
opcode0 = modify_n_opcode(0x0E00);
return E_OK;
}
unsigned char op_mullw(unsigned char * string, unsigned char actual)
{
take_params_n((unsigned char *)string,actual);
opcode0 = modify_n_opcode(0x0D00);
return E_OK;
}
unsigned char op_sublw(unsigned char * string, unsigned char actual)
{
take_params_n((unsigned char *)string,actual);
opcode0 = modify_n_opcode(0x0800);
return E_OK;
}
unsigned char op_xorlw(unsigned char * string, unsigned char actual)
{
take_params_n((unsigned char *)string,actual);
opcode0 = modify_n_opcode(0x0A00);
return E_OK;
}

unsigned char op_clrwdt(unsigned char * string, unsigned char actual)
{
opcode0 = 0x0004;
opcodes = 1;
return E_OK;
}

unsigned char op_daw(unsigned char * string, unsigned char actual)
{
opcode0 = 0x0007;
opcodes = 1;
return E_OK;
}
unsigned char op_nop(unsigned char * string, unsigned char actual)
{
opcode0 = 0x0000;
opcodes = 1;
return E_OK;
}
unsigned char op_pop(unsigned char * string, unsigned char actual)
{
opcode0 = 0x0006;
opcodes = 1;
return E_OK;
}

unsigned char op_push(unsigned char * string, unsigned char actual)
{
opcode0 = 0x0005;
opcodes = 1;
return E_OK;
}
unsigned char op_reset(unsigned char * string, unsigned char actual)
{
opcode0 = 0x00FF;
opcodes = 1;
return E_OK;
}
unsigned char op_retfie(unsigned char * string, unsigned char actual)
{
opcode0 = 0x0010;
opcodes = 1;
return E_OK;
}
unsigned char op_return(unsigned char * string, unsigned char actual)
{
opcode0 = 0x0012;
opcodes = 1;
return E_OK;
}
unsigned char op_sleep(unsigned char * string, unsigned char actual)
{
opcode0 = 0x0003;
opcodes = 1;
return E_OK;
}

unsigned char op_lfsr(unsigned char * string, unsigned char actual)
{
//fs is f by now and fd is k
take_params_fsfd((unsigned char *)string,actual);
opcode0 = 0xEE00;
opcode1 = 0xF000;
if (fs>3) return E_BAD_P1;
if (fd>4096) return E_BAD_P2;
opcode0 = opcode0 | ((fs&0x0003)<<4)|((fd&0x0F00)>>8);
opcode1 = opcode1 | (fd&0x00FF);
opcodes = 2;
return E_OK;
}

unsigned char op_tblrd(unsigned char * string, unsigned char actual)
{
opcode0 = 0x0008;
opcodes = 1;
return E_OK;
}

unsigned char op_tblrdpi(unsigned char * string, unsigned char actual)
{
opcode0 = 0x0009;
opcodes = 1;
return E_OK;
}
unsigned char op_tblrdpd(unsigned char * string, unsigned char actual)
{
opcode0 = 0x000A;
opcodes = 1;
return E_OK;
}
unsigned char op_tblrdip(unsigned char * string, unsigned char actual)
{
opcode0 = 0x000B;
opcodes = 1;
return E_OK;
}

unsigned char op_tblwt(unsigned char * string, unsigned char actual)
{
opcode0 = 0x000C;
opcodes = 1;
return E_OK;
}

unsigned char op_tblwtpi(unsigned char * string, unsigned char actual)
{
opcode0 = 0x000D;
opcodes = 1;
return E_OK;
}
unsigned char op_tblwtpd(unsigned char * string, unsigned char actual)
{
opcode0 = 0x000E;
opcodes = 1;
return E_OK;
}
unsigned char op_tblwtip(unsigned char * string, unsigned char actual)
{
opcode0 = 0x000F;
opcodes = 1;
return E_OK;
}

unsigned char pop_cfg (unsigned char * string, unsigned char actual)
{
int address, value;
unsigned char str_len;
str_len = strlen((char *)string);
opcodes = 0;
str1[0]=0;
str2[0]=0;
actual = get_next_token((unsigned char *)string, (unsigned char*)str1,actual);
actual = get_next_token((unsigned char *)string, (unsigned char*)str2,actual);
if (strlen((char *)str1)>0) 
	if (strlen((char *)str2)>0) 
		{
		address = convert_to_16_number((unsigned char *)str1);
		value = convert_to_16_number((unsigned char *)str2);
		cfg_bits[address] = value;
		}
return E_OK;
}

unsigned char pop_ps (unsigned char * string, unsigned char actual)
{
int address, value;
unsigned char str_len;
str_len = strlen((char *)string);
opcodes = 0;
str1[0]=0;
str2[0]=0;
actual = get_next_token((unsigned char *)string, (unsigned char*)str1,actual);
actual = get_next_token((unsigned char *)string, (unsigned char*)str2,actual);
if (strlen((char *)str1)>0) 
	if (strlen((char *)str2)>0) 
		{
		if (strcmp(str1,"PT")==0)
			{
			if (strcmp(str2,"FK")==0) device.type = P18FK;
			if (strcmp(str2,"18")==0) device.type = P18F;
			if (strcmp(str2,"FJ")==0) device.type = P18FJ;
			}
		if (strcmp(str1,"EB")==0)
			{
			value = convert_to_16_number((unsigned char *)str2);
			device.eblock = value;
			}	
		if (strcmp(str1,"WB")==0)
			{
			value = convert_to_16_number((unsigned char *)str2);
			device.wblock = value;
			}
		if (strcmp(str1,"FW")==0)
			{
			value = convert_to_16_number((unsigned char *)str2);
			device.flash_write = value;
			}	
		if (strcmp(str1,"FE")==0)
			{
			value = convert_to_16_number((unsigned char *)str2);
			device.flash_erase = value;
			}
		if (strcmp(str1,"FS")==0)
			{
			value = convert_to_16_number((unsigned char *)str2);
			device.flash_size = value;
			}	
		if (strcmp(str1,"RU")==0)
			{
			value = convert_to_16_number((unsigned char *)str2);
			device.ram_hb = value;
			}
		if (strcmp(str1,"DC")==0)
			{
			value = convert_to_16_number((unsigned char *)str2);
			device.debug_clock = value;
			}
		}
return E_OK;
}

unsigned char pop_define (unsigned char * string, unsigned char actual)
{
unsigned char str_len,dt_pointer;
str_len = strlen((char *)string);
opcodes = 0;
str1[0]=0;
str2[0]=0;
actual = get_next_token((unsigned char *)string, (unsigned char*)str1,actual);
actual = get_next_token((unsigned char *)string, (unsigned char*)str2,actual);
if (strlen((char *)str1)>0) 
	if (strlen((char *)str2)>0) 
		{
		dt_pointer = update_deftable((unsigned char*)str1,(unsigned char*)str2);
		if (dt_pointer > ((DEFATABLE_LEN/TABLE_ENTRY_LEN)-2)) return E_DEFTAB_OVER;
		}
return E_OK;
}

unsigned char pop_org (unsigned char * string, unsigned char actual)
{
unsigned char str_len;
str_len = strlen((char *)string);
str1[0]=0;
actual = get_next_token((unsigned char *)string, (unsigned char*)str1,actual);
address = convert_to_16_number((unsigned char *)str1);
opcodes = 0;
return 0;
}

#endif
