#include "compiler_low_level.h"
#include "GenericTypeDefs.h"

unsigned char find_next_substring (unsigned char * string, unsigned char actual);
unsigned char get_next_token (unsigned char * source, unsigned char *dest, unsigned char actual);
unsigned char get_opcodes (void);
UINT16 get_opcode0 (void);
UINT16 get_opcode1 (void);
UINT16 get_addr (void);
unsigned char is_number (unsigned char num);
char xtoi_j(const char* xs, UINT16* result);
UINT16 convert_to_16_number (unsigned char * string);
void set_opcodes (unsigned char o);

unsigned char op_addwf(unsigned char * string, unsigned char actual);
unsigned char op_addwfc(unsigned char * string, unsigned char actual);
unsigned char op_andwf(unsigned char * string, unsigned char actual);
unsigned char op_comf(unsigned char * string, unsigned char actual);
unsigned char op_decf(unsigned char * string, unsigned char actual);
unsigned char op_decfsz(unsigned char * string, unsigned char actual);
unsigned char op_dcfsnz(unsigned char * string, unsigned char actual);
unsigned char op_incf(unsigned char * string, unsigned char actual);
unsigned char op_incfsz(unsigned char * string, unsigned char actual);
unsigned char op_infsnz(unsigned char * string, unsigned char actual);
unsigned char op_iorwf(unsigned char * string, unsigned char actual);
unsigned char op_movf(unsigned char * string, unsigned char actual);
unsigned char op_rlcf(unsigned char * string, unsigned char actual);
unsigned char op_rlncf(unsigned char * string, unsigned char actual);
unsigned char op_rrcf(unsigned char * string, unsigned char actual);
unsigned char op_rrncf(unsigned char * string, unsigned char actual);
unsigned char op_subfwb(unsigned char * string, unsigned char actual);
unsigned char op_subwf(unsigned char * string, unsigned char actual);
unsigned char op_subwfb(unsigned char * string, unsigned char actual);
unsigned char op_swapf(unsigned char * string, unsigned char actual);
unsigned char op_xorwf(unsigned char * string, unsigned char actual);

unsigned char op_clrf(unsigned char * string, unsigned char actual);
unsigned char op_cpfseq(unsigned char * string, unsigned char actual);
unsigned char op_cpfsgt(unsigned char * string, unsigned char actual);
unsigned char op_cpfslt(unsigned char * string, unsigned char actual);
unsigned char op_movwf(unsigned char * string, unsigned char actual);
unsigned char op_mulwf(unsigned char * string, unsigned char actual);
unsigned char op_negf(unsigned char * string, unsigned char actual);
unsigned char op_setf(unsigned char * string, unsigned char actual);
unsigned char op_tstfsz(unsigned char * string, unsigned char actual);

unsigned char op_movff(unsigned char * string, unsigned char actual);

unsigned char op_bcf(unsigned char * string, unsigned char actual);
unsigned char op_bsf(unsigned char * string, unsigned char actual);
unsigned char op_btfsc(unsigned char * string, unsigned char actual);
unsigned char op_btfss(unsigned char * string, unsigned char actual);
unsigned char op_btg(unsigned char * string, unsigned char actual);

unsigned char op_bc(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced);
unsigned char op_bn(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced);
unsigned char op_bnc(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced);
unsigned char op_bnn(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced);
unsigned char op_bov(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced);
unsigned char op_bz(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced);
unsigned char op_bnz(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced);
unsigned char op_bnov(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced);

unsigned char op_bra(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced);
unsigned char op_rcall(unsigned char * string, unsigned char actual, UINT16 address,unsigned char replaced);
unsigned char op_call(unsigned char * string, unsigned char actual);
unsigned char op_goto(unsigned char * string, unsigned char actual);

unsigned char op_retlw(unsigned char * string, unsigned char actual);
unsigned char op_addlw(unsigned char * string, unsigned char actual);
unsigned char op_andlw(unsigned char * string, unsigned char actual);
unsigned char op_iorlw(unsigned char * string, unsigned char actual);
unsigned char op_movlb(unsigned char * string, unsigned char actual);
unsigned char op_movlw(unsigned char * string, unsigned char actual);
unsigned char op_mullw(unsigned char * string, unsigned char actual);
unsigned char op_sublw(unsigned char * string, unsigned char actual);
unsigned char op_xorlw(unsigned char * string, unsigned char actual);

unsigned char op_clrwdt(unsigned char * string, unsigned char actual);
unsigned char op_daw(unsigned char * string, unsigned char actual);
unsigned char op_nop(unsigned char * string, unsigned char actual);
unsigned char op_pop(unsigned char * string, unsigned char actual);
unsigned char op_push(unsigned char * string, unsigned char actual);
unsigned char op_reset(unsigned char * string, unsigned char actual);
unsigned char op_return(unsigned char * string, unsigned char actual);
unsigned char op_retfie(unsigned char * string, unsigned char actual);
unsigned char op_sleep(unsigned char * string, unsigned char actual);
unsigned char op_lfsr(unsigned char * string, unsigned char actual);
unsigned char op_tblrd(unsigned char * string, unsigned char actual);
unsigned char op_tblrdpi(unsigned char * string, unsigned char actual);
unsigned char op_tblrdpd(unsigned char * string, unsigned char actual);
unsigned char op_tblrdip(unsigned char * string, unsigned char actual);
unsigned char op_tblwt(unsigned char * string, unsigned char actual);
unsigned char op_tblwtpi(unsigned char * string, unsigned char actual);
unsigned char op_tblwtpd(unsigned char * string, unsigned char actual);
unsigned char op_tblwtip(unsigned char * string, unsigned char actual);


unsigned char pop_define (unsigned char * string, unsigned char actual);
unsigned char pop_org (unsigned char * string, unsigned char actual);
unsigned char pop_cfg (unsigned char * string, unsigned char actual);
unsigned char pop_ps (unsigned char * string, unsigned char actual);




#define	E_OK				0
#define	E_UNKNOWN_OPCODE	1
#define	E_BAD_P1			2
#define	E_BAD_P2			3
#define	E_BAD_P3			4
#define	E_8B_OUT			5
#define	E_11B_OUT			6
#define	E_DEFTAB_OVER		7
#define	E_DEF_UNKNOWN		8
#define	E_FILE_ERROR		9

#define	F_DEFAULT			0
#define	D_DEFAULT			0
#define	A_DEFAULT			0
#define	B_DEFAULT			0
