//#include "stdafx.h"
#include "compiler_low_level.h"
#include "compiler.h"
#include "compiler2.h"
#include "string.h"
#include "substitute.h"
#include "config.h"

unsigned char line_position,error,comp_err,len, token_len,pass,replaced,dt_pointer;
UINT16 file_position,line, opc0,opc1;
unsigned char file_line[24], token[10],opcs;
unsigned char file_line2[24];
UINT16 addr;
extern UINT16 assembled_lines;

#if defined (COMPILER)

void opcode_jump (void);
char write_opcodes (void);
void pseudoopcode_jump (void);
unsigned char compiler_core (void);


unsigned char compiler_run (void)
{
reset_deftable();
line=0;
len = 5;
addr = 0;
file_position = 0;
pass = 1;

while ((len<240)&(len!=0))
{
	len = c_get_line(&file_position,(unsigned char *)&file_line);			//take a line
	if ((len<200)&(len>1)) 
		{
		compiler_core();
		line++;
		}
}

len = 5;
addr = 0;
file_position = 0;
line=0;
pass = 2;
while ((len<240)&(len!=0))
{
	len = c_get_line(&file_position,(unsigned char *)&file_line);			//take a line
	if ((len<200)&(len>1)) 
		{
		comp_err = compiler_core();
		if (comp_err>0)
			{
			return comp_err;
			}
		line++;
		}
}
assembled_lines = line;
return 0;
}

unsigned char compiler_core (void)
{
line_position = find_next_substring((unsigned char*)file_line, 0);		//and find first word
if (line_position>0)													//where is it?
{
	if (line_position<255)
	{																	//this is instruction - outside first row
		error = E_OK;
		if (file_line[line_position]>' ')
		{//non-empty line
			token_len = get_next_token((unsigned char *)file_line,(unsigned char *) token, 0);	//take opcode
			if ((token_len>0)&(token_len<255))																//if valid
			{
				if (token[0]!='#')
					{
					if (pass==2)
						{
						replaced = replace_objects((unsigned char *)file_line,(unsigned char *)file_line2,line_position+token_len);
						if (replaced==255) error = E_DEF_UNKNOWN;
						strcpy((char *)file_line,(char *) file_line2);
						}
					if ((error == E_OK)|(pass==1))
						{
						token_len = get_next_token((unsigned char *)file_line,(unsigned char *) token, 0);	//take opcode
						opcode_jump();						
						}
					}
				else
					{
					pseudoopcode_jump();
					
					}
			}
			else error = E_UNKNOWN_OPCODE;
			if (error==E_OK) 
				{
				if (write_opcodes()!=0) error = E_FILE_ERROR;
				}
			else
				{
				write_output(0xFFFF,error,(unsigned char *)file_line,line);
				}
		}
	}
}
else
{//this is label, first row
	if (pass==1)
		{
		token_len = get_next_token((unsigned char *)file_line,(unsigned char *) token, 0);	//take label name
		if (token_len>0)
			{
			dt_pointer = update_deftable_num((unsigned char *)token, addr);
			if (dt_pointer > ((DEFATABLE_LEN/TABLE_ENTRY_LEN)-2)) return E_DEFTAB_OVER;
			}
		}
}
return error;
}

void opcode_jump (void)
{
	error = E_UNKNOWN_OPCODE;
	//fda group
	if (strcmp( (char *)token,"addwf")==0)		error = op_addwf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"addwfc")==0)		error = op_addwfc((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"andwf")==0)		error = op_andwf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"comf")==0)		error = op_comf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"decf")==0)		error = op_decf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"decfsz")==0)		error = op_decfsz((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"dcfsnz")==0)		error = op_dcfsnz((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"incf")==0)		error = op_incf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"incfsz")==0)		error = op_incfsz((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"infsnz")==0)		error = op_infsnz((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"iorwf")==0)		error = op_iorwf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"movf")==0)		error = op_movf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"rlcf")==0)		error = op_rlcf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"rlncf")==0)		error = op_rlncf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"rrcf")==0)		error = op_rrcf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"rrncf")==0)		error = op_rrncf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"subfwb")==0)		error = op_subfwb((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"subwf")==0)		error = op_subwf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"subwfb")==0)		error = op_subwfb((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"swapf")==0)		error = op_swapf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"xorwf")==0)		error = op_xorwf((unsigned char *) file_line,token_len);
	//fa group
	if (strcmp( (char *)token,"clrf")==0)		error = op_clrf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"cpfseq")==0)		error = op_cpfseq((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"cpfsgt")==0)		error = op_cpfsgt((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"cpfslt")==0)		error = op_cpfslt((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"movwf")==0)		error = op_movwf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"mulwf")==0)		error = op_mulwf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"negf")==0)		error = op_negf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"setf")==0)		error = op_setf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"tstfsz")==0)		error = op_tstfsz((unsigned char *) file_line,token_len);
	//movff
	if (strcmp( (char *)token,"movff")==0)		error = op_movff((unsigned char *) file_line,token_len);
	//fba group
	if (strcmp( (char *)token,"bcf")==0)		error = op_bcf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"bsf")==0)		error = op_bsf((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"btfsc")==0)		error = op_btfsc((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"btfss")==0)		error = op_btfss((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"btg")==0)		error = op_btg((unsigned char *) file_line,token_len);
	//one byte (literal, control) group - decide if relative / absolute
	if (strcmp( (char *)token,"bc")==0)			error = op_bc((unsigned char *) file_line,token_len,addr,replaced);
	if (strcmp( (char *)token,"bn")==0)			error = op_bn((unsigned char *) file_line,token_len,addr,replaced);
	if (strcmp( (char *)token,"bnc")==0)		error = op_bnc((unsigned char *) file_line,token_len,addr,replaced);
	if (strcmp( (char *)token,"bnn")==0)		error = op_bnn((unsigned char *) file_line,token_len,addr,replaced);
	if (strcmp( (char *)token,"bnov")==0)		error = op_bnov((unsigned char *) file_line,token_len,addr,replaced);
	if (strcmp( (char *)token,"bnz")==0)		error = op_bnz((unsigned char *) file_line,token_len,addr,replaced);
	if (strcmp( (char *)token,"bov")==0)		error = op_bov((unsigned char *) file_line,token_len,addr,replaced);
	if (strcmp( (char *)token,"bz")==0)			error = op_bz((unsigned char *) file_line,token_len,addr,replaced);

	if (strcmp( (char *)token,"rcall")==0)		error = op_rcall((unsigned char *) file_line,token_len,addr,replaced);
	if (strcmp( (char *)token,"bra")==0)		error = op_bra((unsigned char *) file_line,token_len,addr,replaced);
	//no decision
	if (strcmp( (char *)token,"retlw")==0)		error = op_retlw((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"addlw")==0)		error = op_addlw((unsigned char *) file_line,token_len);	
	if (strcmp( (char *)token,"andlw")==0)		error = op_andlw((unsigned char *) file_line,token_len);	
	if (strcmp( (char *)token,"iorlw")==0)		error = op_iorlw((unsigned char *) file_line,token_len);	
	if (strcmp( (char *)token,"movlb")==0)		error = op_movlb((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"movlw")==0)		error = op_movlw((unsigned char *) file_line,token_len);	
	if (strcmp( (char *)token,"mullw")==0)		error = op_mullw((unsigned char *) file_line,token_len);	
	if (strcmp( (char *)token,"sublw")==0)		error = op_sublw((unsigned char *) file_line,token_len);	
	if (strcmp( (char *)token,"xorlw")==0)		error = op_xorlw((unsigned char *) file_line,token_len);	
	//goto/call - 2 byte with 16 bit variable
	if (strcmp( (char *)token,"call")==0)		error = op_call((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"goto")==0)		error = op_goto((unsigned char *) file_line,token_len);
	//lfsr
	if (strcmp( (char *)token,"lfsr")==0)		error = op_lfsr((unsigned char *) file_line,token_len);
	//no suffix after opcode
	if (strcmp( (char *)token,"clrwdt")==0)		error = op_clrwdt((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"daw")==0)		error = op_daw((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"nop")==0)		error = op_nop((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"pop")==0)		error = op_pop((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"push")==0)		error = op_push((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"reset")==0)		error = op_reset((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"retfie")==0)		error = op_retfie((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"return")==0)		error = op_return((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"sleep")==0)		error = op_sleep((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"tblrd*")==0)		error = op_tblrd((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"tblrd*+")==0)	error = op_tblrdpi((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"tblrd*-")==0)	error = op_tblrdpd((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"tblrd+*")==0)	error = op_tblrdip((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"tblwt*")==0)		error = op_tblwt((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"tblwt*+")==0)	error = op_tblwtpi((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"tblwt*-")==0)	error = op_tblwtpd((unsigned char *) file_line,token_len);
	if (strcmp( (char *)token,"tblwt+*")==0)	error = op_tblwtip((unsigned char *) file_line,token_len);

}
void pseudoopcode_jump (void)
{
	opcs = 0;
	set_opcodes(0);
	error = E_UNKNOWN_OPCODE;
	if (strcmp( (char *)token,"#def")==0)	
		{
		if (pass==1) error = pop_define((unsigned char *) file_line,token_len);
		else error = E_OK;
		}
	if (strcmp( (char *)token,"#org")==0)		
		{
		error = pop_org((unsigned char *) file_line,token_len);
		addr = get_addr();
		}
	if (strcmp( (char *)token,"#cfg")==0)		
		{
		error = pop_cfg((unsigned char *) file_line,token_len);
		addr = get_addr();
		}
	if (strcmp( (char *)token,"#ps")==0)		
		{
		error = pop_ps((unsigned char *) file_line,token_len);
		addr = get_addr();
		}
}


char write_opcodes (void)
{
	char err;
	opcs = get_opcodes();
	if (pass == 1)
	{
	addr = addr + opcs;
	return;
	}
	if (pass==2)
		{
		if (opcs == 0)
			{
			opc0 = get_opcode0();
			err = write_output(addr,0,(unsigned char *)file_line,line);
			}
		if (opcs == 1) 
			{
			opc0 = get_opcode0();
			err = write_output(addr,opc0,(unsigned char *)file_line,line);
			addr++;
			}
		if (opcs == 2)
			{
			opc0 = get_opcode0();
			opc1 = get_opcode1();
			err = write_output(addr,opc0,(unsigned char *)file_line,line);
			addr++;
			err = write_output(addr,opc1,(unsigned char *)"",line);
			addr++;
			}
		}
return err;
}

#endif
