//#include "stdafx.h"
#include "string.h"
#include "compiler.h"
#include "substitute.h"
#include "stdio.h"
#include "config.h"

extern unsigned char deftable_l[DEFATABLE_LEN];

extern unsigned char deftable_r[DEFATABLE_LEN];

unsigned char new_line[24];
unsigned char deftable_pointer;

#if defined (COMPILER)

const char deftable_c[DT_CONST_SIZE*2][8] =	
	{
	{"abc"},	("0x55"),
	{"def"},	("011"),
	("a"),		("0x0"),
	("abden"),	("0x0000"),
	("abden"),	("0x0000"),
	("abdovf"),	("0x0007"),
	("abdovf"),	("0x0007"),
	("access"),	("0x0"),
	("ackdt"),	("0x0005"),
	("acken"),	("0x0004"),
	("ackstat"),("0x0006"),
	("acqt0"),	("0x0003"),
	("acqt1"),	("0x0004"),
	("acqt2"),	("0x0005"),
	("adcon0"),	("0x0fc2"),
	("adcon1"),	("0x0fc1"),
	("adcon2"),	("0x0fc0"),
	("adcs0"),	("0x0000"),
	("adcs1"),	("0x0001"),
	("adcs2"),	("0x0002"),
	("adden"),	("0x0003"),
	("aden"),	("0x0003"),
	("adfm"),	("0x0007"),
	("adie"),	("0x0006"),
	("adif"),	("0x0006"),
	("adip"),	("0x0006"),
	("adon"),	("0x0000"),
	("adres"),	("0x0fc3"),
	("adresh"),	("0x0fc4"),
	("adresl"),	("0x0fc3"),
	("an10"),	("0x0001"),
	("an11"),	("0x0004"),
	("an12"),	("0x0000"),
	("an4"),	("0x0005"),
	("an8"),	("0x0002"),
	("an9"),	("0x0003"),
	("banked"),	("1"),
	("baudcon"),("0x0fb8"),
	("baudctl"),("0x0fb8"),
	("bclie"),	("0x0003"),
	("bclif"),	("0x0003"),
	("bclip"),	("0x0003"),
	("bf"),		("0x0000"),
	("bgst"),	("0x0005"),
	("bgst"),	("0x0005"),
	("bor"),	("0x0000"),
	("brg16"),	("0x0003"),
	("brg16"),	("0x0003"),
	("brgh"),	("0x0002"),
	("bsr"),	("0x0fe0"),
	("c"),		("0x0000"),
	("c1inv"),	("0x0004"),
	("c1out"),	("0x0006"),
	("c2inv"),	("0x0005"),
	("c2out"),	("0x0007"),
	("ccp1"),	("0x0002"),
	("ccp1con"),("0x0fbd"),
	("ccp1ie"),	("0x0002"),
	("ccp1if"),	("0x0002"),
	("ccp1ip"),	("0x0002"),
	("ccp1m0"),	("0x0000"),
	("ccp1m1"),	("0x0001"),
	("ccp1m2"),	("0x0002"),
	("ccp1m3"),	("0x0003"),
	("ccp1x"),	("0x0005"),
	("ccp1y"),	("0x0004"),
	("ccp2con"),("0x0fba"),
	("ccp2ie"),	("0x0000"),
	("ccp2if"),	("0x0000"),
	("ccp2ip"),	("0x0000"),
	("ccp2m0"),	("0x0000"),
	("ccp2m1"),	("0x0001"),
	("ccp2m2"),	("0x0002"),
	("ccp2m3"),	("0x0003"),
	("ccp2x"),	("0x0005"),
	("ccp2y"),	("0x0004"),
	("ccpr1"),	("0x0fbe"),
	("ccpr1h"),	("0x0fbf"),
	("ccpr1l"),	("0x0fbe"),
	("ccpr2"),	("0x0fbb"),
	("ccpr2h"),	("0x0fbc"),
	("ccpr2l"),	("0x0fbb"),
	("cfgs"),	("0x0006"),
	("cis"),	("0x0003"),
	("ck"),		("0x0006"),
	("cke"),	("0x0006"),
	("ckp"),	("0x0004"),
	("cm0"),	("0x0000"),
	("cm1"),	("0x0001"),
	("cm2"),	("0x0002"),
	("cmcon"),	("0x0fb4"),
	("cmie"),	("0x0006"),
	("cmif"),	("0x0006"),
	("cmip"),	("0x0006"),
	("cren"),	("0x0004"),
	("csrc"),	("0x0007"),
	("cvr0"),	("0x0000"),
	("cvr1"),	("0x0001"),
	("cvr2"),	("0x0002"),
	("cvr3"),	("0x0003"),
	("cvrcon"),	("0x0fb5"),
	("cvren"),	("0x0007"),
	("cvroe"),	("0x0006"),
	("cvrr"),	("0x0005"),
	("cvrss"),	("0x0004"),
	("d"),		("0x0005"),
	("d_a"),	("0x0005"),
	("dc"),		("0x0001"),
	("dc1b0"),	("0x0004"),
	("dc1b1"),	("0x0005"),
	("dc2b0"),	("0x0004"),
	("dc2b1"),	("0x0005"),
	("ddra"),	("0x0f92"),
	("ddrb"),	("0x0f93"),
	("ddrc"),	("0x0f94"),
	("debug"),	("0x0fd4"),
	("done"),	("0x0001"),
	("eeadr"),	("0x0fa9"),
	("eeadrh"),	("0x0faa"),
	("eecon1"),	("0x0fa6"),
	("eecon2"),	("0x0fa7"),
	("eedata"),	("0x0fa8"),
	("eeie"),	("0x0004"),
	("eeif"),	("0x0004"),
	("eeip"),	("0x0004"),
	("eepgd"),	("0x0007"),
	("f"),		("1"),
	("fast"),	("1"),
	("ferr"),	("0x0002"),
	("free"),	("0x0004"),
	("fsr0"),	("0x0"),
	("fsr0h"),	("0x0fea"),
	("fsr0l"),	("0x0fe9"),
	("fsr1"),	("1"),
	("fsr1h"),	("0x0fe2"),
	("fsr1l"),	("0x0fe1"),
	("fsr2"),	("2"),
	("fsr2h"),	("0x0fda"),
	("fsr2l"),	("0x0fd9"),
	("gcen"),	("0x0007"),
	("gie"),	("0x0007"),
	("gieh"),	("0x0007"),
	("giel"),	("0x0006"),
	("go"),		("0x0001"),
	("go_done"),("0x0001"),
	("hlvdcon"),("0x0fd2"),
	("chs0"),	("0x0002"),
	("chs1"),	("0x0003"),
	("chs2"),	("0x0004"),
	("chs3"),	("0x0005"),
	("idlen"),	("0x0007"),
	("indf0"),	("0x0fef"),
	("indf1"),	("0x0fe7"),
	("indf2"),	("0x0fdf"),
	("int0"),	("0x0000"),
	("int0e"),	("0x0004"),
	("int0f"),	("0x0001"),
	("int0ie"),	("0x0004"),
	("int0if"),	("0x0001"),
	("int1"),	("0x0001"),
	("int1e"),	("0x0003"),
	("int1f"),	("0x0000"),
	("int1ie"),	("0x0003"),
	("int1if"),	("0x0000"),
	("int1ip"),	("0x0006"),
	("int1p"),	("0x0006"),
	("int2"),	("0x0002"),
	("int2e"),	("0x0004"),
	("int2f"),	("0x0001"),
	("int2ie"),	("0x0004"),
	("int2if"),	("0x0001"),
	("int2ip"),	("0x0007"),
	("int2p"),	("0x0007"),
	("intcon"),	("0x0ff2"),
	("intcon2"),("0x0ff1"),
	("intcon3"),("0x0ff0"),
	("intedg0"),("0x0006"),
	("intedg1"),("0x0005"),
	("intedg2"),("0x0004"),
	("intsrc"),	("0x0007"),
	("iofs"),	("0x0002"),
	("ipen"),	("0x0007"),
	("ipr1"),	("0x0f9f"),
	("ipr2"),	("0x0fa2"),
	("ircf0"),	("0x0004"),
	("ircf1"),	("0x0005"),
	("ircf2"),	("0x0006"),
	("irvst"),	("0x0005"),
	("lata"),	("0x0f89"),
	("latb"),	("0x0f8a"),
	("latc"),	("0x0f8b"),
	("lvdcon"),	("0x0fd2"),
	("mclr"),	("0x0003"),
	("n"),		("0x0004"),
	("not_a"),	("0x0005"),
	("not_addr"),	("0x0005"),
	("not_bor"),("0x0000"),
	("not_done"),	("0x0001"),
	("not_mclr"),	("0x0003"),
	("not_pd"),	("0x0002"),
	("not_por"),("0x0001"),
	("not_rbpu"),	("0x0007"),
	("not_ri"),	("0x0004"),
	("not_ss"),	("0x0005"),
	("not_t1sy"),	("0x0002"),
	("not_t3sy"),	("0x0002"),
	("not_to"),	("0x0003"),
	("not_w"),	("0x0002"),
	("not_writ"),	("0x0002"),
	("oerr"),	("0x0001"),
	("osccon"),	("0x0fd3"),
	("oscfie"),	("0x0007"),
	("oscfif"),	("0x0007"),
	("oscfip"),	("0x0007"),
	("osctune"),("0x0f9b"),
	("osts"),	("0x0003"),
	("ov"),		("0x0003"),
	("p"),		("0x0004"),
	("pc"),		("0x0ff9"),
	("pcfg0"),	("0x0000"),
	("pcfg1"),	("0x0001"),
	("pcfg2"),	("0x0002"),
	("pcfg3"),	("0x0003"),
	("pcl"),	("0x0ff9"),
	("pclath"),	("0x0ffa"),
	("pclatu"),	("0x0ffb"),
	("pd"),		("0x0002"),
	("peie"),	("0x0006"),
	("pen"),	("0x0002"),
	("pgc"),	("0x0006"),
	("pgd"),	("0x0007"),
	("pgm"),	("0x0005"),
	("pie1"),	("0x0f9d"),
	("pie2"),	("0x0fa0"),
	("pir1"),	("0x0f9e"),
	("pir2"),	("0x0fa1"),
	("pllen"),	("0x0006"),
	("plusw0"),	("0x0feb"),
	("plusw1"),	("0x0fe3"),
	("plusw2"),	("0x0fdb"),
	("por"),	("0x0001"),
	("porta"),	("0x0f80"),
	("portb"),	("0x0f81"),
	("portc"),	("0x0f82"),
	("porte"),	("0x0f84"),
	("postdec0"),	("0x0fed"),
	("postdec1"),	("0x0fe5"),
	("postdec2"),	("0x0fdd"),
	("postinc0"),	("0x0fee"),
	("postinc1"),	("0x0fe6"),
	("postinc2"),	("0x0fde"),
	("pr2"),	("0x0fcb"),
	("preinc0"),	("0x0fec"),
	("preinc1"),	("0x0fe4"),
	("preinc2"),	("0x0fdc"),
	("prod"),	("0x0ff3"),
	("prodh"),	("0x0ff4"),
	("prodl"),	("0x0ff3"),
	("psa"),	("0x0003"),
	("r"),		("0x0002"),
	("r_w"),	("0x0002"),
	("rbie"),	("0x0003"),
	("rbif"),	("0x0000"),
	("rbip"),	("0x0000"),
	("rbpu"),	("0x0007"),
	("rcen"),	("0x0003"),
	("rcidl"),	("0x0006"),
	("rcidl"),	("0x0006"),
	("rcie"),	("0x0005"),
	("rcif"),	("0x0005"),
	("rcip"),	("0x0005"),
	("rcmt"),	("0x0006"),
	("rcmt"),	("0x0006"),
	("rcon"),	("0x0fd0"),
	("rcreg"),	("0x0fae"),
	("rcsta"),	("0x0fab"),
	("rd"),		("0x0000"),
	("rd16"),	("0x0007"),
	("rd16"),	("0x0007"),
	("re3"),	("0x0003"),
	("ri"),		("0x0004"),
	("rsen"),	("0x0001"),
	("rx"),		("0x0007"),
	("rx9"),	("0x0006"),
	("rx9d"),	("0x0000"),
	("rxdtp"),	("0x0005"),
	("rxdtp"),	("0x0005"),
	("s"),		("0x0003"),
	("sboren"),	("0x0006"),
	("sck"),	("0x0003"),
	("sckp"),	("0x0004"),
	("sckp"),	("0x0004"),
	("scl"),	("0x0003"),
	("scs0"),	("0x0000"),
	("scs1"),	("0x0001"),
	("sda"),	("0x0004"),
	("sdi"),	("0x0004"),
	("sdo"),	("0x0005"),
	("sen"),	("0x0000"),
	("sendb"),	("0x0003"),
	("smp"),	("0x0007"),
	("sp0"),	("0x0000"),
	("sp1"),	("0x0001"),
	("sp2"),	("0x0002"),
	("sp3"),	("0x0003"),
	("sp4"),	("0x0004"),
	("spbrg"),	("0x0faf"),
	("spbrgh"),	("0x0fb0"),
	("spen"),	("0x0007"),
	("sren"),	("0x0005"),
	("ss"),		("0x0005"),
	("sspadd"),	("0x0fc8"),
	("sspbuf"),	("0x0fc9"),
	("sspcon1"),("0x0fc6"),
	("sspcon2"),("0x0fc5"),
	("sspen"),	("0x0005"),
	("sspie"),	("0x0003"),
	("sspif"),	("0x0003"),
	("sspip"),	("0x0003"),
	("sspm0"),	("0x0000"),
	("sspm1"),	("0x0001"),
	("sspm2"),	("0x0002"),
	("sspm3"),	("0x0003"),
	("sspov"),	("0x0006"),
	("sspstat"),("0x0fc7"),
	("status"),	("0x0fd8"),
	("stkful"),	("0x0007"),
	("stkovf"),	("0x0007"),
	("stkptr"),	("0x0ffc"),
	("stkptr0"),("0x0000"),
	("stkptr1"),("0x0001"),
	("stkptr2"),("0x0002"),
	("stkptr3"),("0x0003"),
	("stkptr4"),("0x0004"),
	("stkunf"),	("0x0006"),
	("swdte"),	("0x0000"),
	("swdten"),	("0x0000"),
	("sync"),	("0x0004"),
	("t016bit"),("0x0006"),
	("t08bit"),	("0x0006"),
	("t0cki"),	("0x0004"),
	("t0con"),	("0x0fd5"),
	("t0cs"),	("0x0005"),
	("t0ie"),	("0x0005"),
	("t0if"),	("0x0002"),
	("t0ps0"),	("0x0000"),
	("t0ps1"),	("0x0001"),
	("t0ps2"),	("0x0002"),
	("t0se"),	("0x0004"),
	("t13cki"),	("0x0000"),
	("t1cki"),	("0x0000"),
	("t1ckps0"),("0x0004"),
	("t1ckps1"),("0x0005"),
	("t1con"),	("0x0fcd"),
	("t1oscen"),("0x0003"),
	("t1osi"),	("0x0001"),
	("t1oso"),	("0x0000"),
	("t1run"),	("0x0006"),
	("t1sync"),	("0x0002"),
	("t2ckps0"),("0x0000"),
	("t2ckps1"),("0x0001"),
	("t2con"),	("0x0fca"),
	("t2outps0"),	("0x0003"),
	("t2outps1"),	("0x0004"),
	("t2outps2"),	("0x0005"),
	("t2outps3"),	("0x0006"),
	("t3ccp1"),	("0x0003"),
	("t3ccp2"),	("0x0006"),
	("t3ckps0"),("0x0004"),
	("t3ckps1"),("0x0005"),
	("t3con"),	("0x0fb1"),
	("t3sync"),	("0x0002"),
	("tablat"),	("0x0ff5"),
	("tblptr"),	("0x0ff6"),
	("tblptrh"),("0x0ff7"),
	("tblptrl"),("0x0ff6"),
	("tblptru"),("0x0ff8"),
	("tmr0h"),	("0x0fd7"),
	("tmr0ie"),	("0x0005"),
	("tmr0if"),	("0x0002"),
	("tmr0ip"),	("0x0002"),
	("tmr0l"),	("0x0fd6"),
	("tmr0on"),	("0x0007"),
	("tmr1cs"),	("0x0001"),
	("tmr1h"),	("0x0fcf"),
	("tmr1ie"),	("0x0000"),
	("tmr1if"),	("0x0000"),
	("tmr1ip"),	("0x0000"),
	("tmr1l"),	("0x0fce"),
	("tmr1on"),	("0x0000"),
	("tmr2"),	("0x0fcc"),
	("tmr2ie"),	("0x0001"),
	("tmr2if"),	("0x0001"),
	("tmr2ip"),	("0x0001"),
	("tmr2on"),	("0x0002"),
	("tmr3cs"),	("0x0001"),
	("tmr3h"),	("0x0fb3"),
	("tmr3ie"),	("0x0001"),
	("tmr3if"),	("0x0001"),
	("tmr3ip"),	("0x0001"),
	("tmr3l"),	("0x0fb2"),
	("tmr3on"),	("0x0000"),
	("to"),		("0x0003"),
	("tos"),	("0x0ffd"),
	("tosh"),	("0x0ffe"),
	("tosl"),	("0x0ffd"),
	("tosu"),	("0x0fff"),
	("trisa"),	("0x0f92"),
	("trisb"),	("0x0f93"),
	("trisc"),	("0x0f94"),
	("trmt"),	("0x0001"),
	("tx"),		("0x0006"),
	("tx9"),	("0x0006"),
	("tx9d"),	("0x0000"),
	("txckp"),	("0x0004"),
	("txckp"),	("0x0004"),
	("txen"),	("0x0005"),
	("txie"),	("0x0004"),
	("txif"),	("0x0004"),
	("txip"),	("0x0004"),
	("txreg"),	("0x0fad"),
	("txsta"),	("0x0fac"),
	("ua"),		("0x0001"),
	("vcfg0"),	("0x0004"),
	("vcfg1"),	("0x0005"),
	("vdirmag"),("0x0007"),
	("vdirmag"),("0x0007"),
	("vpp"),	("0x0003"),
	("w"),		("0x0"),
	("wcol"),	("0x0007"),
	("wdtcon"),	("0x0fd1"),
	("wr"),		("0x0001"),
	("wreg"),	("0x0fe8"),
	("wren"),	("0x0002"),
	("wrerr"),	("0x0003"),
	("wue"),	("0x0001"),
	("wue"),	("0x0001"),
	("z"),		("0x0002"),
	};



void reset_deftable (void)
{
UINT16 i;
deftable_pointer = 0;
for(i=0;i<DEFATABLE_LEN;i++) 
	{
	deftable_l[i] = 0x00;
	deftable_r[i] = 0x00;
	}

}

unsigned char update_deftable_num (unsigned char * string_l, UINT16 number)
{
unsigned char i;
unsigned char len;
len = strlen((char*)string_l);
sprintf((char *)new_line,"%d",number);
for (i=0;i<len;i++)
	{
	deftable_l[i+(TABLE_ENTRY_LEN*deftable_pointer)] = string_l[i];
	}
len = strlen((char*)new_line);

for (i=0;i<len;i++)
	{
	deftable_r[i+(TABLE_ENTRY_LEN*deftable_pointer)] = new_line[i];
	}
deftable_pointer++;
return deftable_pointer;
}

unsigned char update_deftable (unsigned char * string_l, unsigned char * string_r)
{
unsigned char i;
unsigned char len;
len = strlen((char*)string_l);
for (i=0;i<len;i++)
	{
	deftable_l[i+(TABLE_ENTRY_LEN*deftable_pointer)] = string_l[i];
	}
len = strlen((char*)string_r);

for (i=0;i<len;i++)
	{
	deftable_r[i+(TABLE_ENTRY_LEN*deftable_pointer)] = string_r[i];
	}
deftable_pointer++;
return deftable_pointer;
}


unsigned char search_deftable (unsigned char * string_l, unsigned char * string_r)
{
unsigned char j,str0[8];
UINT16 i,i_temp;
for (i=0;i<deftable_pointer;i++)
	{
		for (j=0;j<8;j++) str0[j] = deftable_l[j+(i*TABLE_ENTRY_LEN)];
		if (strcmp((char *)str0,(char *)string_l)==0)
		{
		for (j=0;j<8;j++)
			{
			string_r[j] = deftable_r[j+i*TABLE_ENTRY_LEN];
			}
		return i;
		}
	}

for (i=0;i<DT_CONST_SIZE;i++)
	{
//		for (j=0;j<8;j++) str0[j] = deftable_c[i*2][j];

/*		i_temp = i<<1;
		str0[0] = deftable_c[i_temp][0];
		str0[1] = deftable_c[i_temp][1];
		str0[2] = deftable_c[i_temp][2];
		str0[3] = deftable_c[i_temp][3];
		str0[4] = deftable_c[i_temp][4];
		str0[5] = deftable_c[i_temp][5];
		str0[6] = deftable_c[i_temp][6];
		str0[7] = deftable_c[i_temp][7];
*/
		i_temp = i<<4;
		str0[0] = * (&deftable_c[0][0] + i_temp + 0);
		str0[1] = * (&deftable_c[0][0] + i_temp + 1);
		str0[2] = * (&deftable_c[0][0] + i_temp + 2);
		str0[3] = * (&deftable_c[0][0] + i_temp + 3);
		str0[4] = * (&deftable_c[0][0] + i_temp + 4);
		str0[5] = * (&deftable_c[0][0] + i_temp + 5);
		str0[6] = * (&deftable_c[0][0] + i_temp + 6);
		str0[7] = * (&deftable_c[0][0] + i_temp + 7);

		if (strcmp((char *)str0,(char *)string_l)==0)
		{
		for (j=0;j<8;j++)
			{
			string_r[j] = deftable_c[(i*2)+1][j];
			}
		return i;
		}
	}


return 255;
}


unsigned char replace_objects (unsigned char * old_string, unsigned char * new_string, unsigned char actual)
{
unsigned char str0[7],replaced[8];
unsigned char str_len,rep_len,substitutions,actual_old,i,err;
str_len = strlen((char *)old_string);
for (i=0;i<24;i++) new_line[i] = 0x00;
substitutions = 0;
actual_old = actual;
for (i=0;i<actual;i++) new_line[i] = old_string[i];
while (actual<str_len)
	{
	str0[0]=0;
	actual = get_next_token((unsigned char *)old_string, (unsigned char*)str0,actual);
	if (actual<255)
		{
		if (is_number(str0[0]))
			{
			strcat((char *)new_line,(char *)str0);
			strcat ((char *)new_line,",");
			actual_old = actual;
			}
		else
			{
			err = search_deftable((unsigned char *)str0,(unsigned char*)replaced);
			if (err==255) return 255;
			rep_len = strlen((char *)replaced);
			strcat ((char *)new_line,(char *)replaced);
			strcat ((char *)new_line,",");
			actual_old = actual;
			substitutions++;
			}
		}
	}
strcpy((char *)new_string,(char *) new_line);
return substitutions;
}

#endif
