#include "other.h"
#include "plib.h"
#include "HardwareProfile.h"

//#define	DEBSIM

//	/*
#define	COMPILER
#define	EDITOR
#define	PRINT
#define	DE
#define	DEBUGGER
#define	INTERRUPT
//	*/

#define	DEBUGGER_MAIN

#define __ICD2RAM

//#define FLASH_BUFFERING

#define	FCY		GetSystemClock()
#define	FPB		GetPeripheralClock()

#define	INPUT_SIZE	2000
#define	OUTPUT_SIZE	4096

#define	DEFATABLE_LEN	1024	//number of defines - DEFTABLE_LEN/TABLE_ENTRY_LEN
#define	TABLE_ENTRY_LEN	8
#define	DT_CONST_SIZE	440

#define	VPP_8V		475
#define	VPP_13V		755


#define	NEW_LINE	0x0A
#define	BACKSPACE	0x08
#define	K_UP		0x1C
#define	K_DN		0x1D
#define	K_LT		0x1E
#define	K_RT		0x1F
#define	ESCAPE		0x1B

#define	D_S_RAM		1
#define	D_S_WATCH	0
#define	D_S_FLASH	2
#define	D_S_BKP		3
#define	D_S_LAST	4

#define	D_M_RUN		0
#define	D_M_SSTEP	1
#define	D_M_RST		2
#define	D_M_EXIT	3
#define	D_M_LAST	4


typedef union
{
struct
 {
    unsigned esc:1;
    unsigned ent:1;
    unsigned bsp:1;
    unsigned shf:1;
    unsigned up:1;
    unsigned lt:1;
    unsigned dn:1;
 	unsigned rt:1;
 };
unsigned char CHAR;
}kspec; 

typedef union
{
struct
 {
    unsigned edit:1;
    unsigned update:1;
    unsigned var:3;
    unsigned b5:1;
    unsigned b6:1;
 	unsigned b7:1;
 };
unsigned char CHAR;
}debug_var; 

typedef union
{
struct
 {
    unsigned b0:1;
    unsigned b1:1;
    unsigned b2:1;
    unsigned b3:1;
    unsigned b4:1;
    unsigned b5:1;
    unsigned b6:1;
 	unsigned b7:1;
 };
unsigned char CHAR;
}flag_var; 

typedef union
{
struct
 {
    unsigned led:1;
    unsigned sw_en:1;
    unsigned sw_sw:1;
    unsigned b3:1;
    unsigned b4:1;
    unsigned b5:1;
    unsigned b6:1;
 	unsigned b7:1;
 };
unsigned char CHAR;
}se_var; 


typedef struct _DEVICE {
	unsigned char type;	
	UINT16 wblock;
	UINT16 eblock;
	UINT16 flash_size;
	UINT16 flash_erase;
	UINT16 flash_write;
	unsigned char ram_hb;
	UINT16 debug_clock;		//in microseconds
} DEVICE;


#define	P18F	1
#define	P18FJ	2
#define	P18FK	3
#define	DEVICE_MAX	4


#define	DIR_INPUT	0
#define	DIR_OUTPUT	1

#define ICSP_PGD_INPUT	ICSP_PGDP_T=1;ICSP_PGDD_T=0;ICSP_PGDD=0;
#define ICSP_PGD_OUTPUT	ICSP_PGDP_T=0;ICSP_PGDD_T=0;ICSP_PGDD=1;
#define ICSP_PGC_INPUT	ICSP_PGCP_T=1;ICSP_PGCD_T=0;ICSP_PGCD=0;
#define ICSP_PGC_OUTPUT	ICSP_PGCP_T=0;ICSP_PGCD_T=0;ICSP_PGCD=1;

#define	ICSP_PGDP_T	TRISFbits.TRISF13
#define	ICSP_PGD	LATFbits.LATF13
#define	ICSP_PGD_I	PORTFbits.RF13
#define	ICSP_PGDD_T	TRISAbits.TRISA10
#define	ICSP_PGDD	LATAbits.LATA10
#define	ICSP_PGDD_I	PORTAbits.RA10

#define	ICSP_PGC	LATAbits.LATA2
#define	ICSP_PGCP_T	TRISAbits.TRISA2
#define	ICSP_PGC_I	PORTAbits.RA2
#define	ICSP_PGCD	LATFbits.LATF12
#define	ICSP_PGCD_T	TRISFbits.TRISF12
#define	ICSP_PGCD_I	PORTFbits.RF12

#define	ICSP_MCLRH		LATBbits.LATB11
#define	ICSP_MCLRH_T	TRISBbits.TRISB11
#define	ICSP_MCLRL		LATCbits.LATC4
#define	ICSP_MCLRL_T	TRISCbits.TRISC4


#define	K_R1	LATEbits.LATE9
#define	K_R2	LATDbits.LATD1
#define	K_R3	LATCbits.LATC14
#define	K_R4	LATDbits.LATD0
#define	K_R5	LATEbits.LATE8
#define	K_R6	LATFbits.LATF5
#define	K_R7	LATFbits.LATF4
#define	K_C1	PORTDbits.RD4
#define	K_C2	PORTDbits.RD3
#define	K_C3	PORTDbits.RD12


#define	K_R1_T	TRISEbits.TRISE9
#define	K_R2_T	TRISDbits.TRISD1
#define	K_R3_T	TRISCbits.TRISC14
#define	K_R4_T	TRISDbits.TRISD0
#define	K_R5_T	TRISEbits.TRISE8
#define	K_R6_T	TRISFbits.TRISF5
#define	K_R7_T	TRISFbits.TRISF4
#define	K_C1_T	TRISDbits.TRISD4
#define	K_C2_T	TRISDbits.TRISD3
#define	K_C3_T	TRISDbits.TRISD12

#define	STDIO_LOCAL	0
#define	STDIO_TTY1	1

#define	TBUF_LEN	2048
#define	TERM_WIDTH	16
#define	TERM_LINES	8

typedef struct
	{ 
	char* name; 
	unsigned char (*func)(unsigned char * args);
	} sc;

