#include "stdio.h"
//#include "iic.h"
//#include "keyb.h"
#include "string.h"
#include "config.h"
#include "debug.h"
#include "editor.h"


#define	short_delay	delay_cyc(50)
extern int vreg_set;
extern UINT16 output_file[OUTPUT_SIZE];
extern UINT16 cfg_bits[8];
extern UINT16 test_file[256];
extern DEVICE	device;

#ifdef	DE
extern const UINT16 de_18FK_01[256];
extern const UINT16 de_18FK_02[256];
extern const UINT16 de_18FK_05[256];
extern const UINT16 de_18FK_0E[256];
extern const UINT16 de_18FJ_03[256];
extern const UINT16 de_18F_01[256];
extern const UINT16 de_18F_02[256];
extern const UINT16 de_18F_03[256];
extern const UINT16 de_18F_05[256];
extern const UINT16 de_18F_07[256];
extern const UINT16 de_18F_0C[256];
extern const UINT16 de_18F_0E[256];
#endif

#define	CYC_DELAY	delay_cyc(1);

UINT16 tttt;

void set_tblptr (UINT16 address);
void write_cfg (unsigned char offset, UINT16 data);

void rst_target(void)
	{
	vreg_set = 0;	
	delay_ms(70);
	ICSP_PGD_INPUT
	ICSP_PGC_INPUT
	ICSP_MCLRH = 0;
	ICSP_MCLRL = 1;
	delay_ms(10);
	ICSP_MCLRL = 0;
	ICSP_MCLRH = 1;
	delay_ms(10);
	}

void enter_lp_icsp(unsigned char devtype)
	{
	if (devtype == P18F)
		{
		ICSP_MCLRH_T = 0;
		ICSP_MCLRH = 0;
		ICSP_MCLRL_T = 0;
		ICSP_MCLRL = 0;
		ICSP_PGD_OUTPUT
		ICSP_PGC_OUTPUT
		ICSP_PGD = 0;
		ICSP_PGC = 0;
		vreg_set = VPP_13V;
		delay_ms(50);
		ICSP_MCLRH = 0;
		ICSP_MCLRL = 1;
		delay_ms(20);
		ICSP_MCLRH = 1;
		ICSP_MCLRL = 0;
		delay_ms(3);
		}
	if (devtype == P18FK)
		{
		ICSP_MCLRH_T = 0;
		ICSP_MCLRH = 0;
		ICSP_MCLRL_T = 0;
		ICSP_MCLRL = 0;
		ICSP_PGD_OUTPUT
		ICSP_PGC_OUTPUT
		ICSP_PGD = 0;
		ICSP_PGC = 0;
		vreg_set = VPP_8V;
		delay_ms(100);
		ICSP_MCLRH = 0;
		ICSP_MCLRL = 1;
		delay_ms(100);
		ICSP_MCLRH = 1;
		ICSP_MCLRL = 0;
		
		delay_ms(3);
		}
	if (devtype == P18FJ)
		{
		ICSP_MCLRH_T = 0;
		ICSP_MCLRH = 0;
		ICSP_MCLRL_T = 0;
		ICSP_MCLRL = 0;
		vreg_set = 0;
		delay_ms(10);
		ICSP_PGD_OUTPUT
		ICSP_PGC_OUTPUT
		ICSP_PGD = 0;
		ICSP_PGC = 0;
		ICSP_MCLRH = 0;
		ICSP_MCLRL = 1;
		delay_ms(1);
		ICSP_MCLRH = 1;
		ICSP_MCLRL = 0;
		delay_ms(1);
		ICSP_MCLRH = 0;
		ICSP_MCLRL = 1;
		delay_ms(1);
		write_byte_icsp(0x4D);
		write_byte_icsp(0x43);
		write_byte_icsp(0x48);
		write_byte_icsp(0x50);
		delay_ms(1);
		ICSP_MCLRH = 1;
		ICSP_MCLRL = 0;
		delay_ms(10);
		}
	}


void bulk_erase (unsigned char devtype)
	{
	unsigned char i;
	ICSP_PGD_OUTPUT
	ICSP_PGC_OUTPUT
	if (devtype==P18FJ)
		{
		write_icsp_data(0x00,0x0E3C);
		write_icsp_data(0x00,0x6EF8);
		write_icsp_data(0x00,0x0E00);
		write_icsp_data(0x00,0x6EF7);
		write_icsp_data(0x00,0x0E05);
		write_icsp_data(0x00,0x6EF6);
		write_icsp_data(0x0D,0x0101);
		write_icsp_data(0x00,0x0E3C);
		write_icsp_data(0x00,0x6EF8);
		write_icsp_data(0x00,0x0E00);
		write_icsp_data(0x00,0x6EF7);
		write_icsp_data(0x00,0x0E04);
		write_icsp_data(0x00,0x6EF6);
		write_icsp_data(0x0D,0x8080);
		write_icsp_data(0x00,0x0000);
		}
	if (devtype==P18FK)
		{
		write_icsp_data(0x00,0x0E3C);
		write_icsp_data(0x00,0x6EF8);
		write_icsp_data(0x00,0x0E00);
		write_icsp_data(0x00,0x6EF7);
		write_icsp_data(0x00,0x0E05);
		write_icsp_data(0x00,0x6EF6);
		write_icsp_data(0x0D,0x0F0F);
		write_icsp_data(0x00,0x0E3C);
		write_icsp_data(0x00,0x6EF8);
		write_icsp_data(0x00,0x0E00);
		write_icsp_data(0x00,0x6EF7);
		write_icsp_data(0x00,0x0E04);
		write_icsp_data(0x00,0x6EF6);
		write_icsp_data(0x0D,0x8F8F);
		write_icsp_data(0x00,0x0000);
		}
	for (i=0;i<4;i++)
		{
		ICSP_PGD = 0;
		delay_cyc(30);
		ICSP_PGC = 1;
		delay_cyc(30);
		ICSP_PGC = 0;
		delay_cyc(30);
		}
	if (devtype==P18FJ)
		{
		for (i=0;i<110;i++)
			{
			delay_ms(6);
			}
		}
	if (devtype==P18FK)
		{
		delay_ms(6);
		}
	for (i=0;i<16;i++)
		{
		ICSP_PGD = 0;
		delay_cyc(30);
		ICSP_PGC = 1;
		delay_cyc(30);
		ICSP_PGC = 0;
		delay_cyc(30);
		}
	
	
	}

void write_byte_icsp (unsigned char data)
{
	unsigned char i;
	ICSP_PGD_OUTPUT
	ICSP_PGC_OUTPUT
	for (i=0;i<8;i++)
		{
		if (data&0x80) ICSP_PGD =1;
			else ICSP_PGD = 0;
		delay_cyc(20);
		ICSP_PGC = 1;
		delay_cyc(20);
		data = data<<1;
		ICSP_PGC = 0;
		delay_cyc(20);
		}
}

void leave_lp_icsp (unsigned char hold)
{
	ICSP_PGD_OUTPUT
	ICSP_PGC_OUTPUT
	ICSP_PGD = 0;
	ICSP_PGC = 0;
	ICSP_MCLRH = 0;
	ICSP_MCLRL = 1;
	delay_ms(1);
	ICSP_MCLRH = 1;
	ICSP_MCLRL = 0;
	ICSP_PGD_INPUT
	ICSP_PGD_INPUT
	vreg_set = 0;
	delay_ms(50);
}

void write_cfg (unsigned char offset, UINT16 data)
{
	write_icsp_data(0x00,0x8EA6);
	write_icsp_data(0x00,0x8CA6);
	write_icsp_data(0x00,0xEF00);
	write_icsp_data(0x00,0xF800);
	
	write_icsp_data(0x00,0x0E30);
	write_icsp_data(0x00,0x6EF8);
	write_icsp_data(0x00,0x0E00);
	write_icsp_data(0x00,0x6EF7);
	write_icsp_data(0x00,(0x0E00+offset));
	write_icsp_data(0x00,0x6EF6);
	write_icsp_data(0x0F,data);
	modified_nop(10);					//to meet all P9 parameters
										//10ms in more, but for configs
										//it is ok
	
	write_icsp_data(0x00,0x2AF6);
	
	write_icsp_data(0x0F,data);
	modified_nop(10);
	
}


void write_icsp_data (unsigned char cmd, UINT16 data)
	{
	unsigned char i;
	ICSP_PGD_OUTPUT
	for (i=0;i<4;i++)
		{
		ICSP_PGD = (cmd&0x01);
		delay_cyc(1);
		ICSP_PGC = 1;
		delay_cyc(1);
		cmd = cmd>>1;
		ICSP_PGC = 0;
		delay_cyc(1);
		}
	for (i=0;i<16;i++)
		{
		ICSP_PGD = (data&0x01);
		delay_cyc(1);
		ICSP_PGC = 1;
		delay_cyc(1);
		data = data>>1;
		ICSP_PGC = 0;
		delay_cyc(1);
		}
	}

unsigned char read_icsp_data (unsigned char cmd)
	{
	unsigned char i;
	UINT16 data;
	ICSP_PGD_OUTPUT
	for (i=0;i<4;i++)
		{
		ICSP_PGD = (cmd&0x01);
		delay_cyc(1);
		ICSP_PGC = 1;
		delay_cyc(1);
		cmd = cmd>>1;
		ICSP_PGC = 0;
		delay_cyc(1);
		}
	ICSP_PGD = 0;
	delay_cyc(1);
	for (i=0;i<8;i++)
		{
		ICSP_PGC = 1;
		delay_cyc(1);
		ICSP_PGC = 0;
		delay_cyc(1);
		}
	data = 0;
	ICSP_PGD_INPUT
	for (i=0;i<8;i++)
		{
		ICSP_PGC = 1;
		delay_cyc(1);
		ICSP_PGC = 0;
		delay_cyc(1);
		data = data>>1;
		if (ICSP_PGD_I==1) data = data|0x80;
		delay_cyc(1);
		}
	return data;
	}


void modified_nop(UINT16 delay)
	{
	unsigned char i;
	ICSP_PGD_OUTPUT
	ICSP_PGC = 0;
	ICSP_PGD = 0;
	delay_cyc(1);
	ICSP_PGC = 1;
	delay_cyc(1);
	ICSP_PGC = 0;
	delay_cyc(1);
	ICSP_PGC = 1;
	delay_cyc(1);
	ICSP_PGC = 0;
	delay_cyc(1);
	ICSP_PGC = 1;
	delay_cyc(1);
	ICSP_PGC = 0;
	delay_cyc(1);
	
	ICSP_PGC = 1;
	delay_ms(delay);
	ICSP_PGC = 0;
	delay_ms(1);
	for (i=0;i<16;i++)
		{
		delay_cyc(1);
		ICSP_PGC = 1;
		delay_cyc(1);
		ICSP_PGC = 0;
		delay_cyc(1);
		}
	
	}


void set_tblptr (UINT16 address)
	{
	UINT16 temp;
	write_icsp_data(0x00,0x0E00);
	write_icsp_data(0x00,0x6EF8);
	temp  = ((address>>8)&0x00FF) | 0x0E00;
	write_icsp_data(0x00,temp);
	write_icsp_data(0x00,0x6EF7);
	temp  = (address&0x00FF) | 0x0E00;
	write_icsp_data(0x00,temp);
	write_icsp_data(0x00,0x6EF6);
	}

unsigned char write_flash_block (UINT16 pointer, DEVICE dev)
	{
	unsigned char i;
	UINT16 temp;
	if (dev.type == P18F)
		{
		write_icsp_data(0x00,0x8EA6);
		write_icsp_data(0x00,0x9CA6);
		
		set_tblptr(pointer*2);
		
		for (i=0;i<(dev.wblock -1);i++) 
			{
			temp = output_file[pointer+i];
			write_icsp_data(0x0D,temp);
			}
		temp = output_file[pointer+(dev.wblock-1)];
		write_icsp_data(0x0F,temp);
		modified_nop(2);
		}
	if (dev.type == P18FK)
		{
		write_icsp_data(0x00,0x8EA6);
		write_icsp_data(0x00,0x9CA6);
		write_icsp_data(0x00,0x84A6);
		set_tblptr(pointer*2);	
		for (i=0;i<(dev.wblock -1);i++) 
			{
	//		set_tblptr((pointer+i)*2);
			temp = output_file[pointer+i];
			write_icsp_data(0x0D,temp);
			}
	//	set_tblptr((pointer+(device.wblock-1))*2);
		temp = output_file[pointer+(dev.wblock-1)];
		write_icsp_data(0x0F,temp);
	//	set_tblptr(pointer*2);	
		modified_nop(5);
		}
	if (dev.type == P18FJ)
		{
		write_icsp_data(0x00,0x84A6);
		set_tblptr(pointer*2);
		for (i=0;i<(dev.wblock -1);i++) 
			{
			temp = output_file[pointer+i];
			write_icsp_data(0x0D,temp);
			}
		temp = output_file[pointer+(dev.wblock-1)];
		write_icsp_data(0x0F,temp);
		modified_nop(4);
		}
	
	return 0;
	}

UINT16 verify_flash(UINT16 size)
	{
	UINT16 i;
	UINT16 temp;
	write_icsp_data(0x00,0x0E00);
	write_icsp_data(0x00,0x6EF8);
	write_icsp_data(0x00,0x0E00);
	write_icsp_data(0x00,0x6EF7);
	write_icsp_data(0x00,0x0E00);
	write_icsp_data(0x00,0x6EF6);
	for (i=0;i<size;i++)
		{
		temp = (UINT16) (read_icsp_data(0x09));
		temp = temp | ((UINT16) (read_icsp_data(0x09))<<8);
		if (output_file[i] != temp) 
				{
				return i;
				}
		}
	return 0xFFFF;
	
	}

unsigned char erase_flash_block (UINT16 address, unsigned char devtype)
	{
	if (devtype == P18F)
		{
		write_icsp_data(0x00,0x8EA6);
		write_icsp_data(0x00,0x9CA6);
		
		set_tblptr(address);
		
		write_icsp_data(0x00,0x84A6);
		write_icsp_data(0x00,0x88A6);
		write_icsp_data(0x00,0x82A6);
		modified_nop(2);
		}
	if (devtype == P18FK)
		{
		write_icsp_data(0x00,0x8EA6);
		write_icsp_data(0x00,0x9CA6);
		write_icsp_data(0x00,0x84A6);	
		set_tblptr(address);
		
		write_icsp_data(0x00,0x88A6);
		write_icsp_data(0x00,0x82A6);
		modified_nop(5);
		}
	
	if (devtype == P18FJ)
		{
		write_icsp_data(0x00,0x84A6);	
		set_tblptr(address);
	//	write_icsp_data(0x00,0x6AF8);	
	//	write_icsp_data(0x00,0x6AF7);	
	//	write_icsp_data(0x00,0x6AF6);	
		write_icsp_data(0x00,0x88A6);
		write_icsp_data(0x00,0x82A6);
		modified_nop(70);
		}
	return 0;
	}

unsigned char read_flash_out (UINT16 len)
	{
	UINT16 i;
	UINT16 temp;
	write_icsp_data(0x00,0x0E00);
	write_icsp_data(0x00,0x6EF8);
	write_icsp_data(0x00,0x0E00);
	write_icsp_data(0x00,0x6EF7);
	write_icsp_data(0x00,0x0E00);
	write_icsp_data(0x00,0x6EF6);
	for (i=0;i<len;i++)
		{
		temp = (UINT16) (read_icsp_data(0x09));
		temp = temp | ((UINT16) (read_icsp_data(0x09))<<8);
		output_file[i] = temp;
		}
	
	return 0;
	}


unsigned char read_flash_out_t (unsigned long addr, UINT16 len)
	{
	UINT16 i;
	UINT16 temp;
	
	temp = ((UINT16) (addr>>16)) & 0x00FF;
	temp = temp | 0x0E00;
	write_icsp_data(0,temp);
	write_icsp_data(0,0x6EF8);
	
	temp = ((UINT16) (addr>>8)) & 0x00FF;
	temp = temp | 0x0E00;
	write_icsp_data(0,temp);
	write_icsp_data(0,0x6EF7);
	
	temp = ((UINT16) (addr)) & 0x00FF;
	temp = temp | 0x0E00;
	write_icsp_data(0,temp);
	write_icsp_data(0,0x6EF6);
	
	
	for (i=0;i<len;i++)
		{
		temp = (UINT16) (read_icsp_data(0x09));
		temp = temp | ((UINT16) (read_icsp_data(0x09))<<8);
		output_file[i] = temp;
		}
	
	return 0;
	}

UINT16 return_id (unsigned char devtyp)
	{
	UINT16 temp;
	write_icsp_data(0x00,0x0E3F);
	write_icsp_data(0x00,0x6EF8);
	write_icsp_data(0x00,0x0EFF);
	write_icsp_data(0x00,0x6EF7);
	write_icsp_data(0x00,0x0EFE);
	write_icsp_data(0x00,0x6EF6);
	temp = (UINT16) (read_icsp_data(0x09));
	temp = temp | ((UINT16) (read_icsp_data(0x09))<<8);
	return temp;
	}


void write_debug_vector (DEVICE dev)
	{
	UINT16 i;
	
	if (device.type == P18FJ)
		{
		write_icsp_data(0x00,0x84A6);
	
		write_icsp_data(0x00,0x0E20);
		write_icsp_data(0x00,0x6EF8);
		
		write_icsp_data(0x00,0x0E00);
		write_icsp_data(0x00,0x6EF7);
		
		write_icsp_data(0x00,0x0E00);
		write_icsp_data(0x00,0x6EF6);
		for (i=0;i<0x14;i++) write_icsp_data(0x0D,0x0000);
		write_icsp_data(0x0D,0xEF00);
		write_icsp_data(0x0D,0xF020);
		for (i=0;i<0x09;i++) write_icsp_data(0x0D,0x0000);
		write_icsp_data(0x0F,0x0000);
		modified_nop(4);
		}
	
	if (device.type == P18F)
		{
		write_icsp_data(0x00,0x0E20);
		write_icsp_data(0x00,0x6EF8);
		
		write_icsp_data(0x00,0x0E00);
		write_icsp_data(0x00,0x6EF7);
		
		write_icsp_data(0x00,0x0E28);
		write_icsp_data(0x00,0x6EF6);
		
	//	for (i=0;i<0x14;i++) write_icsp_data(0x0D,0x0000);
		i = dev.flash_size-0x0800+1;
		i=i>>1;
		write_icsp_data(0x0D,0xEF00|(i&0x00FF));
		write_icsp_data(0x0D,0xF000|((i>>8)&0x00FF));
	//	for (i=0;i<0x09;i++) write_icsp_data(0x0D,0x0000);
		write_icsp_data(0x0F,0x0000);
		modified_nop(2);
		}
	if (device.type == P18FK)
		{
		write_icsp_data(0x00,0x0E20);
		write_icsp_data(0x00,0x6EF8);
		
		write_icsp_data(0x00,0x0E00);
		write_icsp_data(0x00,0x6EF7);
		
		write_icsp_data(0x00,0x0E28);
		write_icsp_data(0x00,0x6EF6);
		
	//	for (i=0;i<0x14;i++) write_icsp_data(0x0D,0x0000);
		i = dev.flash_size-0x0800+1;
		i=i>>1;
		write_icsp_data(0x0D,0xEF00|(i&0x00FF));
		write_icsp_data(0x0D,0xF000|((i>>8)&0x00FF));
	//	for (i=0;i<0x09;i++) write_icsp_data(0x0D,0x0000);
		write_icsp_data(0x0F,0x0000);
		modified_nop(2);
		}
	}
	
	#ifdef	DE
	void write_debug_exec (DEVICE dev)
	{
	UINT16 addr;
	for (addr = 0; addr < (256); addr = addr + dev.wblock) 
		{
		write_flash_block_de(addr,dev);
		}
	
	}
#endif

unsigned char write_flash_block_de (UINT16 pointer,DEVICE dev)
	{
	unsigned char i;
	volatile UINT16 tmp2;
	UINT16 *array;
	if (dev.type == P18F)
		{
		switch (dev.ram_hb)
			{
			#ifdef	DE
			case 0x01: array = (UINT16 *)&de_18F_01; break;
			case 0x02: array = (UINT16 *)&de_18F_02; break;
			case 0x03: array = (UINT16 *)&de_18F_03; break;						
			case 0x05: array = (UINT16 *)&de_18F_05; break;
			case 0x07: array = (UINT16 *)&de_18F_07; break;
			case 0x0C: array = (UINT16 *)&de_18F_0C; break;
			case 0x0E: array = (UINT16 *)&de_18F_0E; break;
			#endif
			}
		write_icsp_data(0x00,0x8EA6);
		write_icsp_data(0x00,0x9CA6);
		set_tblptr(dev.flash_size-0x0800+1+ (pointer*2));
		for (i=0;i<(dev.wblock -1);i++) 
			{
			tmp2 = array[i+pointer];
			write_icsp_data(0x0D,tmp2);
			}
		tmp2 = array[pointer+dev.wblock-1];
		write_icsp_data(0x0F,tmp2);
		modified_nop(2);
		}
	if (dev.type == P18FK)
		{
		switch (dev.ram_hb)
			{
			#ifdef	DE
			case 0x01: array = (UINT16 *)&de_18FK_01; break;
			case 0x02: array = (UINT16 *)&de_18FK_02; break;
   			case 0x05: array = (UINT16 *)&de_18FK_05; break;
			case 0x0E: array = (UINT16 *)&de_18FK_0E; break;
			#endif
			}
		write_icsp_data(0x00,0x8EA6);
		write_icsp_data(0x00,0x9CA6);
		set_tblptr(dev.flash_size-0x0800+1+ (pointer*2));
		for (i=0;i<(dev.wblock -1);i++) 
			{
			tmp2 = array[i+pointer];
			write_icsp_data(0x0D,tmp2);
			}
		tmp2 = array[pointer+dev.wblock-1];
		write_icsp_data(0x0F,tmp2);
		modified_nop(2);
		}
	if (dev.type == P18FJ)
		{
 		switch (dev.ram_hb)
			{
			#ifdef	DE
			case 0x03: array = (UINT16 *)&de_18FJ_03; break;
			#endif
			}
		write_icsp_data(0x00,0x84A6);
		write_icsp_data(0x00,0x0E20);
		write_icsp_data(0x00,0x6EF8);
		write_icsp_data(0x00,0x0E00+((unsigned char)((pointer*2)>>8)));
		write_icsp_data(0x00,0x6EF7);
		write_icsp_data(0x00,(0x0E00+ ((unsigned char)(pointer*2))));
		write_icsp_data(0x00,0x6EF6);
		for (i=0;i<(dev.wblock -1);i++) 
			{
			tmp2 = array[i+pointer];
			write_icsp_data(0x0D,tmp2);
			}
		tmp2 = array[(dev.wblock-1)+pointer];
		write_icsp_data(0x0F,tmp2);
		modified_nop(4);
	//	delay_ms(100);
		}
	
	return 0;
	}

#ifdef DEBUGGER
void read_debug_vector (void)
	{
	UINT16 i;
	UINT16 temp;
	write_icsp_data(0x00,0x0E20);
	write_icsp_data(0x00,0x6EF8);
	write_icsp_data(0x00,0x0E00);
	write_icsp_data(0x00,0x6EF7);
	write_icsp_data(0x00,0x0E00);
	write_icsp_data(0x00,0x6EF6);
	for (i=0;i<32;i++)
		{
		temp = (UINT16) (read_icsp_data(0x09));
		temp = temp | ((UINT16) (read_icsp_data(0x09))<<8);
	//	test_file[i] = temp;
		}
	
	}
	
void read_debug_exec (void)
	{
	UINT16 i;
	UINT16 temp;
	write_icsp_data(0x00,0x0E00);
	write_icsp_data(0x00,0x6EF8);
	write_icsp_data(0x00,0x0EF8);
	write_icsp_data(0x00,0x6EF7);
	write_icsp_data(0x00,0x0E00);
	write_icsp_data(0x00,0x6EF6);
	for (i=0;i<256;i++)
		{
		temp = (UINT16) (read_icsp_data(0x09));
		temp = temp | ((UINT16) (read_icsp_data(0x09))<<8);
	//	test_file[i] = temp;
		}
	}

void erase_debug_exec (DEVICE dev)
	{
	UINT16 addr;
	if (dev.type == P18F)
		{
		for (addr=0;addr<0x0800;addr=addr+ dev.eblock) 
			erase_flash_block(dev.flash_size-0x0800+1+addr,dev.type);
		}
	if (dev.type == P18FJ)
		{
		write_icsp_data(0x00,0x84A6);	
		write_icsp_data(0x00,0x0E20);
		write_icsp_data(0x00,0x6EF8);
		write_icsp_data(0x00,0x0E00);
		write_icsp_data(0x00,0x6EF7);
		write_icsp_data(0x00,0x0E00);
		write_icsp_data(0x00,0x6EF6);
		write_icsp_data(0x00,0x88A6);
		write_icsp_data(0x00,0x82A6);
		modified_nop(70);
		delay_ms(100);
		}
	}


void erase_debug_vector (void)
	{
	//only for PIC18
	write_icsp_data(0x00,0x8EA6);
	write_icsp_data(0x00,0x9CA6);
	
	write_icsp_data(0x00,0x0E20);
	write_icsp_data(0x00,0x6EF8);
	write_icsp_data(0x00,0x0E00);
	write_icsp_data(0x00,0x6EF7);
	write_icsp_data(0x00,0x0E00);
	write_icsp_data(0x00,0x6EF6);
	
	write_icsp_data(0x00,0x84A6);
	write_icsp_data(0x00,0x88A6);
	write_icsp_data(0x00,0x82A6);
	modified_nop(3);
	
	delay_ms(8);
	}


unsigned char bdm_entry (void)
	{
	di();
	ICSP_PGC_OUTPUT
	ICSP_PGD_INPUT
	ICSP_PGD = 1;
	delay_us(device.debug_clock	);
	ICSP_PGC = 1;
	delay_us(device.debug_clock	);
	ICSP_PGC = 0;
	if (wait_for_bdm()==0) return 0;
		else return 1;
	ei();
	}

unsigned char wait_for_bdm (void)
	{
	//ICSP_PGD_INPUT
	//while (ICSP_PGD_I==0);
	TMR2 = 0;
	PR2 = 2 * (FPB / 1000);		//timeout 2ms
	IFS0bits.T2IF = 0;
	T2CONbits.TON = 1;
	while (1)
		{
		if (ICSP_PGD_I==1) return 1;
		if (IFS0bits.T2IF == 1) return 0;
		}
	}

void write_debug (unsigned char data)
	{
	unsigned char count;
	ICSP_PGD_OUTPUT
	ICSP_PGC_OUTPUT
	for (count = 0; count <8 ; count++)
	{
		delay_us(device.debug_clock	* 2);
		ICSP_PGC = 1;
		delay_us(device.debug_clock	);
		ICSP_PGD_OUTPUT
		delay_us(device.debug_clock	);
		if (data&0x01) ICSP_PGD = 1;
			else ICSP_PGD = 0;
		data = data>>1;
		delay_us(device.debug_clock	);
		ICSP_PGC = 0;
	}
	delay_us(device.debug_clock	*3);
	ICSP_PGD_INPUT
	}

unsigned char read_debug (void)
	{
	unsigned char data,count;
	ICSP_PGD_INPUT
	ICSP_PGC_OUTPUT
	data = 0;
	for (count = 0; count <8 ; count++)
	{
		delay_us(device.debug_clock	);
		ICSP_PGC = 1;
		delay_us(device.debug_clock	);
		ICSP_PGC = 0;
		delay_us(device.debug_clock	);
		data = data>>1;
		if (ICSP_PGD_I == 1) 
			{
			data = data|0x80;
			}
	}
	delay_us(device.debug_clock	*3);
	ICSP_PGD_INPUT
	return data;
	}

unsigned char bdm_r1w(unsigned char par)
	{
	unsigned char data;
	write_debug(par);
	data = read_debug();
	return data;
	}

UINT16 bdm_r2w(unsigned char par)
	{
	unsigned char data;
	UINT16 data2;
	write_debug(par);
	data = read_debug();
	data2 = read_debug();
	data2 = data2 | (((UINT16)(data))<<8);
	return data2;
	}

unsigned char bdm_r1w2(unsigned char cmd, UINT16 par)
	{
	unsigned char data;
	write_debug(cmd);
	write_debug(((unsigned char)(par>>8)));
	write_debug(((unsigned char)(par)));
	data = read_debug();
	return data;
	}


unsigned char check_state (void)
	{
	ICSP_PGD_INPUT
	if (ICSP_PGD_I==1) return 1;
		else return 0;
	}

UINT16 debug_rfl (UINT16 addr)
	{
	unsigned char data;
	UINT16 datai;
	data = bdm_r1w2(6,addr+1);
	datai = bdm_r1w2(6,addr);
	datai = datai | (((UINT16)(data))<<8);
	return datai;
	}

unsigned char debug_write_ram (UINT16 addr, unsigned char data)
	{
	write_debug(0x0A);
	write_debug(((unsigned char)(addr>>8)));
	write_debug(((unsigned char)(addr)));
	write_debug (data);
	return (read_debug());
	}
#endif

