#include "stdio.h"
//#include "iic.h"
//#include "keyb.h"
#include "string.h"
#include "config.h"
#include "debug.h"
#include "editor.h"

extern UINT16 output_file[OUTPUT_SIZE];
extern UINT16 cfg_bits[8];
extern UINT16 test_file[256];

UINT16 prog_enter_icsp (DEVICE dev)
	{
	enter_lp_icsp(dev.type);
	return 0;
	}


UINT16 prog_leave_icsp (DEVICE dev)
	{
	leave_lp_icsp(0);
	return 0;
	}

UINT16 prog_get_devid (DEVICE dev)
	{
	UINT16 devid;
	devid = return_id(dev.type);
	//devid = devid >> 5;
	return devid;
	}


UINT16 prog_get_devrev (DEVICE dev)
	{
	UINT16 devrev;
	devrev = return_id(dev.type);
	devrev = devrev&0x01F;
	return devrev;
	}

UINT16 prog_erase_flash (DEVICE dev)
	{
	UINT16 addr;
	if (dev.type==P18F)
		{
		for (addr=0;addr<( 2 * dev.flash_erase );addr=addr+ dev.eblock) 
			erase_flash_block(addr, dev.type );
		}
	if (dev.type==P18FK)
		{
		bulk_erase(dev.type);
		}
	if (dev.type==P18FJ)
		{
		bulk_erase(dev.type);
		}
	return 0;
	}


UINT16 prog_write_flash (DEVICE dev)
	{
	UINT16 addr;
	for (addr = 0; addr < ( dev.flash_write ); addr = addr + dev.wblock) 
		{
		write_flash_block(addr,dev);
		}
	return 0;
	}

UINT16 prog_verify_flash (DEVICE dev)
	{
	UINT16 result;
	result = verify_flash( dev.flash_write);
	return result;
	}

UINT16 prog_write_cfgs (DEVICE dev)
	{
	if (dev.type == P18F)
		{
		write_cfg(0,cfg_bits[0]);
		write_cfg(2,cfg_bits[1]);
		write_cfg(4,cfg_bits[2]);
		write_cfg(6,cfg_bits[3]);
		}
	if (dev.type == P18FK)
		{
		write_cfg(0,cfg_bits[0]);
		write_cfg(2,cfg_bits[1]);
		write_cfg(4,cfg_bits[2]);
		write_cfg(6,cfg_bits[3]);
		}
	if (dev.type == P18FJ)
		{
	//	erase_flash_block(0x7F00,dev.type);
		write_icsp_data(0x00,0x84A6);
		set_tblptr(dev.flash_size - 7); 
		write_icsp_data(0x0D,cfg_bits[0]);
		write_icsp_data(0x0D,cfg_bits[1]);
		write_icsp_data(0x0D,cfg_bits[2]);
		write_icsp_data(0x0F,0xFFFF);
		modified_nop(4);
		}
	return 0;
	}

UINT16 prog_verify_cfgs (DEVICE dev)
	{
	return 0;
	}

UINT16 debug_erase_device (DEVICE dev)
	{
	if (dev.type==P18FJ)
		{
		bulk_erase(dev.type);
		}
	if (dev.type==P18F)
		{
		prog_erase_flash(dev);
		#ifdef	DEBUGGER
		erase_debug_exec(dev);
		erase_debug_vector();
		#endif
		}
	if (dev.type==P18FK)
		{
		bulk_erase(dev.type);
		}
	return 0;
	}

UINT16 debug_write_de (DEVICE dev)
	{
	if (dev.type==P18F)
		{
		write_debug_vector(dev);
		}
	if (dev.type==P18FK)
		{
			#ifdef	DEBUGGER
		write_debug_vector(dev);
		#endif
		}
	#ifdef	DEBUGGER
	write_debug_exec(dev);
	#endif
	return 0;
	}


