#include <stdio.h>
//#include "iic.h"
//#include "keyb.h"
#include "string.h"
#include "compiler2.h"
#include "substitute.h"
#include "config.h"
#include "disp.h"
#include "editor.h"

extern unsigned volatile char key_char, key_stat;
extern unsigned char disp_buffer[160];
extern unsigned char input_file[INPUT_SIZE];
extern kspec keys_spec;
extern UINT16 file_len;

UINT16 p_actual_pointer, file_pointer, file_prep_pointer, actual_line;
unsigned char cursor_x,linelen,key_stat_old,editor_state;
#pragma code
void init_editor (void)
{
file_pointer = 0;
editor_state = 1;
}

void clear_disp_buffer (void)
{
unsigned char i;
for (i=0;i<128;i++) disp_buffer[i]=' ';

}


unsigned char editor_task (void)
{
#if defined (EDITOR)
file_len = get_file_len();
if (file_pointer>file_len) file_pointer = file_len-1;
if (file_pointer>INPUT_SIZE) file_pointer = INPUT_SIZE-1;
actual_line = get_line (file_pointer, &cursor_x);	//file pointer points to actual position in file, so compute line number
file_prep_pointer = find_line (actual_line);		//and from this, compute pointer to start of that line
if (file_prep_pointer>file_len) file_prep_pointer = file_len;
prepare_disp_buffer(file_prep_pointer);				//draw to window from this position
delay_ms(20);
linelen = get_linelen(file_prep_pointer);
//display();
editor_state = 1;
check_spec_keys();
if (key_stat==1)
	{
	key_stat = 3;
	if (key_stat_old == 0) insert_character (key_char, file_pointer);
	else input_file[file_pointer] = key_char;
	}

if (key_stat==2)
	{
	input_file[file_pointer] = key_char;
//	insert_character (key_char, file_pointer);
	file_pointer++;
	key_stat = 0;
	}
key_stat_old = key_stat;
#endif
return editor_state;
}

#if defined (EDITOR)
void check_spec_keys (void)
{
if (keys_spec.esc)
	{
	keys_spec.esc = 0;
	editor_state = 2;
	}

if (keys_spec.bsp)
	{
	if (file_pointer>0)
		{
		file_pointer--;
		backspace(file_pointer);
		}
	keys_spec.bsp = 0;
	}

if (keys_spec.ent)
	{
//	input_file[file_pointer] = NEW_LINE;
	insert_character(NEW_LINE,file_pointer);
	file_pointer++;
	if (input_file[file_pointer] == 0x00)
		{
		input_file[file_pointer] = ' ';
		file_pointer++;
		}
	keys_spec.ent = 0;
	}

if (keys_spec.rt)
	{
	file_pointer++;
	keys_spec.rt = 0;
	}
if (keys_spec.lt)
	{
	if (file_pointer>0) file_pointer--;
	keys_spec.lt = 0;
	}
if (keys_spec.dn)
	{
	actual_line++;
	file_len = get_file_len();
	file_prep_pointer = find_line (actual_line);		//and from this, compute pointer to start of that line
	if (file_prep_pointer>file_len) file_prep_pointer = file_len;
	linelen = get_linelen(file_prep_pointer);
	if (linelen>cursor_x) 	file_pointer = file_prep_pointer + cursor_x;
		else file_pointer = file_prep_pointer + linelen;
	keys_spec.dn = 0;
	}
if (keys_spec.up)
	{
	if (actual_line>0)
		{
		actual_line--;
		file_prep_pointer = find_line (actual_line);		//and from this, compute pointer to start of that line
		file_pointer = file_prep_pointer;
		linelen = get_linelen(file_prep_pointer);
		if (linelen>cursor_x) 	file_pointer = file_prep_pointer + cursor_x;
			else file_pointer = file_prep_pointer + linelen;
		}
	keys_spec.up = 0;
	}

}


void backspace (UINT16 pointer)
{
UINT16 i;
if (pointer>=0) 
	if (pointer<INPUT_SIZE) 
		for (i=pointer; i<INPUT_SIZE;i++)
			{
			input_file[i] = input_file[i+1];
			}
}


void insert_character (unsigned char what, UINT16 pointer)
{
UINT16 i;
unsigned char temp;
for (i=INPUT_SIZE; i>pointer;i--)
	{
	temp = input_file[i-1];
	input_file[i] = temp;
	}
input_file[pointer] = what;

}

#endif

/*
void display (void)
{
gotoxy(0,0);
putslcd2(disp_buffer);
gotoxy(0,1);
putslcd2(disp_buffer+16);
gotoxy(0,2);
putslcd2(disp_buffer+32);
gotoxy(0,3);
putslcd2(disp_buffer+48);
gotoxy(0,4);
putslcd2(disp_buffer+64);
gotoxy(0,5);
putslcd2(disp_buffer+80);
gotoxy(0,6);
putslcd2(disp_buffer+96);
gotoxy(0,7);
putslcd2(disp_buffer+112);
}
*/
unsigned char is_printable (unsigned char what)
{
if ((what>=' ')&(what<='z')) 
	return 1;
else return 0;

}


//return line number from file pointer
UINT16 get_line (UINT16 pointer, unsigned char * cur_pos)
{
UINT16 line,pp;
unsigned char cp;
line = 0;
pp=0;
cp=0;
while (pp!=pointer)
 	{
	if (input_file[pp]==NEW_LINE) 
		{
		line++;
		cp=0;
		}
	else cp++;
	if (input_file[pp]==0x00) 
		{
		return 0xFFFF;
		}
	pp++;
	}
*cur_pos = cp;
return line;
}

unsigned char get_linelen (UINT16 pointer)
{
unsigned char linlen;
linlen=0;
while ((input_file[pointer]!=NEW_LINE)&(input_file[pointer]!=0x00))
	{
	pointer++;
	linlen++;
	if (linelen==255) return 255;
	}
return linlen;
}

//return pointer to beginning of line from line number
UINT16 find_line (UINT16 line)
{
UINT16 pointer;
UINT16 actual_line;
actual_line = 0;
pointer = 0;
while (actual_line!=line)
	{
	if (input_file[pointer] == NEW_LINE) actual_line++;
	pointer++;
	if (pointer>1000) return 0xFFFF;
	}
return pointer;
}

#if defined (EDITOR)

//prepare disp buffer from given pointer - should be at beginning of line - from find_line
void prepare_disp_buffer (UINT16 start_pointer)
{
UINT16 p;
unsigned long r;
unsigned char db_p,db_o;
p = start_pointer;
di();
for (db_o=0;db_o<128;db_o = db_o + 16)
	{
	db_p = 0;
	while ((is_printable(input_file[p]))&(db_p<16))
		{
		disp_buffer[db_o+db_p] = input_file[p];
		if (db_o==0) disp_buffer[db_o+cursor_x] = disp_buffer[db_o+cursor_x] | 0x80;
		db_p++;
		p++;
		}
	while (db_p<16)
		{
		disp_buffer[db_o+db_p] = ' ';
		if (db_o==0) disp_buffer[db_o+cursor_x] = disp_buffer[db_o+cursor_x] | 0x80;
		db_p++;
		}
	while (is_printable(input_file[p])==0)
		{
		p++;
		}
	}
sprintf ((char *)disp_buffer+112,"                ");
p = file_pointer;
p = p * 100;
p = p / file_len;
r = file_len;
r = r * 100;
r = r / INPUT_SIZE;
sprintf ((char *)disp_buffer+112,"L%d,%d%%,M%d%%   ",actual_line,((UINT16)(p)),((UINT16)(r)));
ei();
}

#endif 


void clear_input_file (void)
{
UINT16 i;
for (i=0;i<INPUT_SIZE;i++) input_file[i] = ' ';
input_file[1] = 0x00;
}

UINT16 get_file_len (void)
{
UINT16 i;
i=0;
while (input_file[i]>0) 
	{
	i++;
	}
return i;
}


