#include "config.h"
#include <plib.h>
#include "FSDefs.h"
#include "FSConfig.h"
extern unsigned char disp_buffer[160];

unsigned long last_addr;
unsigned char unwritten;

void init_hw (void)
{

OSCCONbits.FRCDIV = 0x01;
SYSTEMConfigPerformance(GetSystemClock());
//mOSCSetPBDIV(OSC_PB_DIV_2);
I2CConfigure(I2C1, I2C_ENABLE_SLAVE_CLOCK_STRETCHING);
I2CSetFrequency(I2C1, GetPeripheralClock(), 500000);
if (I2C1BRG<2) I2C1BRG = 2;
I2CEnable(I2C1, TRUE);

PR2 = 40*(FPB / 8 / 1000);
T2CONbits.TCKPS0 = 1;
T2CONbits.TCKPS1 = 1;
T2CONbits.TON = 1;
IEC0bits.T2IE = 1;	
IPC2bits.T2IP = 3;

PR4 = (FPB / 8 / 1000)/2;
T4CONbits.TCKPS0 = 1;
T4CONbits.TCKPS1 = 1;
T4CONbits.TON = 1;
IEC0bits.T4IE = 1;	
IPC4bits.T4IP = 2;

AD1CON3bits.ADRC = 1;
AD1CON3bits.SAMC = 10;
AD1CHS = 0x0303;
AD1CON1bits.ON = 1;
AD1CON1bits.SSRC = 0b111;


PR3 = 150;
OC3RS = 1;
OC3R = 1;
OC3CONbits.OCTSEL = 0b001;
OC3CONbits.OCM = 0b110;
//OC3CONbits.SYNCSEL = 0x1F;
T3CONbits.TON = 1;
OC3CONbits.ON = 1;


K_R1_T = 0;
K_R2_T = 0;
K_R3_T = 0;
K_R4_T = 0;
K_R5_T = 0;
K_R6_T = 0;
K_R7_T = 0;
K_C1_T = 1;
K_C2_T = 1;
K_C3_T = 1;

ICSP_PGD_OUTPUT
ICSP_PGC_OUTPUT
ICSP_MCLRH_T = 0;
ICSP_MCLRH = 0;
ICSP_MCLRL_T = 0;
ICSP_MCLRL = 0;



}

void delay_ms(UINT16 number)
{
int i;
TMR1 = 0;
PR1 = FPB / 1000;
IFS0bits.T1IF = 0;
T1CONbits.TON = 1;
for (i=0;i<number;i++) 
	{
	IFS0bits.T1IF = 0;
	while (IFS0bits.T1IF == 0);
	}
T1CONbits.TON = 0;
}

void delay_cyc(UINT16 number)
{
TMR1 = 0;
PR1 = number;
IFS0bits.T1IF = 0;
T1CONbits.TON = 1;
while (IFS0bits.T1IF == 0);
}

void delay_cyc_int(UINT16 number)
{
TMR5 = 0;
PR5 = number;
IFS0bits.T5IF = 0;
T5CONbits.TON = 1;
while (IFS0bits.T5IF == 0);
}

void delay_us (UINT16 number)
{
TMR1 = 0;
PR1 = (FPB / 1000000) * number;
IFS0bits.T1IF = 0;
T1CONbits.TON = 1;
while (IFS0bits.T1IF == 0);
}



void di(void)
{
IEC0bits.T2IE = 0;
}

void ei(void)
{
#ifdef	INTERRUPT
IEC0bits.T2IE = 1;
#endif
}

