#include <plib.h>
#include <stdio.h>
#include <ctype.h>
#include "disp.h"
#include "FSIO.h"
#include "config.h"
#include "apps_hl.h"
#include "other.h"
#include "keyb.h"
#include "editor.h"

char stdio_src;

char term_buffer[TBUF_LEN];
char term_screen_buffer[TERM_WIDTH*TERM_LINES];
char term_input[50],term_input_p,term_key_stat_old;
UINT16 term_pointer,vertical_shift;

unsigned char disp_buffer[160];
unsigned char display_refresh_rate,dat;
unsigned char key_mode;
flag_var flags;
unsigned char global_state;
UINT16 ppp;
UINT16 tmr_1ms;
//SearchRec           searchRecord;
unsigned char fil_key_stat_old,file_name_len;

unsigned char file_name[30],file_name_tmp[30];
FSFILE * file_1;

//keyb variables
unsigned char key_m_stat, key_item,key_mo_count,char_m;
UINT16 keys_old_m,keys,m_ko,m_ko2;
unsigned char key_m_stat, key_item,key_mo_count,char_m, keys_spec_old, keys_spec_new,keys_ar_count;
UINT16 keys_old_m,keys,m_ko,m_ko2,k_old,verify_result,tkeys,i;
kspec keys_spec;
unsigned volatile char key_char, key_stat;

//regulator
int vreg_err,vreg_temp,vreg_set,vreg_perr,vreg_p_factor,vreg_i_factor;
UINT16 adc_hv,adc_lv,adc_bat,adc_res_reg_old;
unsigned char adc_counter,adc_chnl;

unsigned char cmd_line_buff[30], cmd_line_pointer,cmd_line_key_stat_old,prompt;

unsigned char execute_line (unsigned char * line);

unsigned char rx_sta (void);
unsigned char rx_read (void);
void tx_write (unsigned char data);


void terminal_init(void);
unsigned char terminal_tasks (char * input, UINT16 * shift);
char term_k_stat (void);
char term_k_char (char * out);

sc cases [] = 
{ { "ls", app_run_ls }
, { "ad", app_run_ad }
, { "cd", app_run_cd }
, { "cp", app_run_cp }
, { "re", app_run_re }
, { "er", app_run_er }
, { "md", app_run_md }
, { "rd", app_run_rd }
, { "ed", app_run_ed }
, { "as", app_run_as }
, { "pg", app_run_pg }
, { "de", app_run_de }
, { "bf", app_run_bf }
, { "ba", app_run_ba }
, { "te", app_run_te }
, { "t0", app_run_t0 }
, { "~~~~", 0 }
};


void main_init (void)
	{
	delay_ms(10);
	init_hw();
	#ifndef	DEBSIM
	init_disp();
	#endif
	vreg_p_factor = 1;
	vreg_i_factor = 4;	
	INTEnableSystemMultiVectoredInt();
	vreg_set = 0;
	vreg_perr = 0;
	flags.CHAR = 0;
	key_mode = 1;
	clear_disp_buffer();
	global_state = 0;
	display_refresh_rate = 1;
	file_name_tmp[0] = 0;
	
	terminal_init();
		
	U1MODEbits.ON = 1;
	U1STAbits.URXEN = 1;
	U1STAbits.UTXEN = 1;
	U1BRG = ((FPB)/(16*19200)) - 1;
	prompt = 1;
	stdio_src = 0;
	stdio_write("\n - PP4 v 1.0 - \n");
	stdio_write("\nSD init... ");
	while (!FSInit());
	stdio_write("OK\n");
	}

unsigned char rx_sta (void)
{
if (U1STAbits.URXDA==1) return 0xFF;
	else return 0x00;
}
unsigned char rx_read (void)
{
return U1RXREG;
}
void tx_write (unsigned char data)
{
U1TXREG = data;
while (U1STAbits.UTXBF==1);
}


unsigned char stdio_write (unsigned char * data)
{
if (stdio_src==STDIO_LOCAL)
	terminal_tasks(data,&vertical_shift);
else if (stdio_src==STDIO_TTY1)
	{
	while (*data!=0x00)
	tx_write(*data++);
	}
}

unsigned char stdio_c (unsigned char data)
{
char tmp[3];
if (stdio_src==STDIO_LOCAL)
	{
	tmp[0] = data;
	tmp[1] = 0;
	terminal_tasks(tmp,&vertical_shift);
	}
else if (stdio_src==STDIO_TTY1)
	tx_write(data);
}

char stdio_get (char * dat)
{
if (stdio_src==STDIO_LOCAL)
	{
	return term_k_char(dat);
	}
else if (stdio_src==STDIO_TTY1)
	{
	if (rx_sta()!=0)
		{
		*dat++=rx_read();
		*dat++=0;
		return 1;
		}
	else
		return 0;
	}
return 0;
}


unsigned char main_loop (unsigned char inp)
{
unsigned char *ptr;
unsigned char data,len,i,retval;
char sstr[3];
if (prompt==1)
	{
	stdio_write("#");	
	prompt = 0;
	}
if (stdio_get(sstr)!=0)
	{
	stdio_write(sstr);
	if (sstr[0]==0x0A) 
		{
			if (cmd_line_buff[0]!=0)
				{
				string_lower(cmd_line_buff);
				retval = execute_line (cmd_line_buff);
				switch (retval)
					{
					case APP_RETVAL_OK:
//						stdio_write("-OK\n");
						break;
					case APP_RETVAL_PAR:
						stdio_write("-err:par\n");
						break;			
					case APP_RETVAL_FOE:
						stdio_write("-err:f_op\n");
						break;		
					case APP_RETVAL_FWE:
						stdio_write("-err:f_wr\n");
						break;	
					case APP_RETVAL_UE:
						stdio_write("-err:uns\n");
						break;
					case APP_RETVAL_NE:
						stdio_write("-err:cmd\n");
						break;	
					case APP_RETVAL_MEM:
						stdio_write("-err:mem\n");
						break;										
					}
				}
			cmd_line_pointer=0;
			cmd_line_buff[0] = 0;
			prompt = 1;
		}	
	else
		{
			len = strlen(sstr);
			for (i=0;i<len;i++)
				{
				if (sstr[i]>0x1F) cmd_line_buff[cmd_line_pointer++] = sstr[i];
				else if (sstr[i]==0x08)
					{
					if (cmd_line_pointer>0) cmd_line_buff[cmd_line_pointer--]=0;
					}
				}
		}	

	}
cmd_line_buff[cmd_line_pointer]=0;
cmd_line_key_stat_old = key_stat;
}

unsigned char execute_line (unsigned char * line)
{
unsigned char *ptr,line_cmd_len,line_arg_len;
unsigned char line_cmd[15],line_arg[30],retval,i;
ptr = (unsigned char *)strpbrk((char *)line," ");
if (ptr!= NULL)	
	{
	line_cmd_len = ptr - line;
	strncpy((char *)line_cmd,(char *)line,line_cmd_len);
	line_cmd[line_cmd_len] = 0x00;
	line_arg_len = strlen(ptr+1);
	strcpy((char *)line_arg,(char *)(ptr+1));
	}
else
	{
	strcpy((char *)line_cmd,(char *)line);	
	line_arg[0]=0;
	line_arg_len = 0;
	}
line_arg[line_arg_len]=0;
retval = APP_RETVAL_NE;
i=0;
while (cases[i].func!=0)
	{
	if (strcmp(cases[i].name,line_cmd)==0)
		{		
		retval = cases[i].func(line_arg);	
		break;
		}	
	i++;
	}
return retval;
}


//40 ms
void __ISR(_TIMER_2_VECTOR, ipl3) Timer2Handler(void)
{
	IFS0bits.T2IF = 0;
	
	#ifndef	DEBSIM
	display();
	#endif
	keys = detect_keys();
	if (key_mode==1)
		{
		if (keys==k_old) 
			{
			if (k_old != 0x00)
				{
				k_old = keys;
				keys = keys&0xFF00;
				}
			else k_old = keys;
			}
			else k_old = keys;
		keys_m();
		if ((key_m_stat&0x0F)==1)
			{
			key_char = char_m;
			key_stat = 1;
			}
		
		if ((key_m_stat&0x0F)==2)
			{
			key_m_stat = key_m_stat&0xF0;
			key_char = char_m;
			key_stat = 2;
			}
		keys_spec_new = (keys>>8);
		if (keys_spec_new!=keys_spec_old) keys_spec.CHAR = keys_spec.CHAR|keys_spec_new;
		if ((keys_spec_new==keys_spec_old)&((keys_spec_old&0xF0)!=0))
			{
			keys_ar_count++;
			if (keys_ar_count==15)
				{
					keys_ar_count = 10;
					keys_spec.CHAR = keys_spec.CHAR|keys_spec_new;
				}
			}
		else
			{
				keys_ar_count = 0;
			}	
		
		keys_spec_old = keys_spec_new;
		}		
	else
		{
		keys_spec_new = (keys>>8);
		if (keys_spec_new!=keys_spec_old) keys_spec.CHAR = keys_spec.CHAR|keys_spec_new;
		keys_spec_old = keys_spec_new;
		if ((keys&0x00FF) !=0)
			{
			key_char = keys;
			key_stat = 1;
			}
		}
}

//1ms
void __ISR(_TIMER_4_VECTOR, ipl2) Timer4Handler(void)
{
	IFS0bits.T4IF = 0;

	
	volatile UINT16 adc_res;

	adc_res = ADC1BUF0;	
	if ((adc_counter&0x01)==0)
		{
		//vreg adc_read
		adc_res_reg_old = adc_res;
		vreg_err = vreg_set - adc_res;
		vreg_perr = vreg_perr + vreg_err;
//		vreg_temp = vreg_err>>3;
//		vreg_temp = vreg_temp + (vreg_perr>>6);
		vreg_temp = vreg_err/7;
		vreg_temp = vreg_temp + (vreg_perr/50);
		if (vreg_perr>10000) vreg_perr = 10000;
		if (vreg_perr<-10000) vreg_perr = -10000;
		if(vreg_temp<0) vreg_temp = 0;
		if (vreg_temp>90) vreg_temp = 90;
		OC3RS = vreg_temp;

		if (adc_counter==0x00)
			adc_chnl = 9;
		if (adc_counter==0x02)
			adc_chnl = 10;
		AD1CHS = ((unsigned long)(adc_chnl))<<16; 
		tmr_1ms++;
		}
	else
		{
		if (adc_chnl==9)	//lv
			{
			adc_lv = adc_res;
			}
		if (adc_chnl==10)	//hv
			{
			adc_hv = adc_res;
			}
		AD1CHS = 0x080000; //set channel to vreg	
 		}
	adc_counter++;
	if (adc_counter==0x04) adc_counter = 0;
	AD1CON1bits.SAMP = 1;

	
}


unsigned char open_file_dialog (unsigned char * filename)
{
unsigned char i;
key_mode = 1;
strcpy(file_name_tmp,filename);
di();
clear_disp_buffer();
if (file_name_tmp[0]==0) 
	{
	for (i=0;i<sizeof(file_name_tmp);i++) file_name_tmp[i]=i;
	file_name_len = 0;
	}
sprintf ((char *)disp_buffer+0,"Open file");
sprintf ((char *)disp_buffer+16,file_name_tmp);
disp_buffer[16+file_name_len] = disp_buffer[16+file_name_len] | 0x80;
ei();
if (key_stat==1)
	{
	key_stat = 3;
	if (fil_key_stat_old == 0) insert_character_gen (toupper(key_char), file_name_len, file_name_tmp);
	else file_name_tmp[file_name_len] = toupper(key_char);
	}

if (key_stat==2)
	{
	file_name_tmp[file_name_len] = toupper(key_char);
//	insert_character (key_char, file_pointer);
	file_name_len++;
	key_stat = 0;
	}
fil_key_stat_old = key_stat;
if (keys_spec.bsp)
	{
	if (file_name_len>0)
		{
		file_name_len--;
		backspace_gen(file_name_len,file_name_tmp);
		}
	keys_spec.bsp = 0;
	}
if (keys_spec.ent)
	{
	keys_spec.ent = 0;
	file_1 = FSfopen (file_name_tmp, "r");
	if (file_1 != NULL)
		{
		FSfclose (file_1);
		strcpy(filename,file_name_tmp);
		return 1;
		}
	else
		{
		sprintf ((char *)disp_buffer+32,"DNE");
		}
	}
if (keys_spec.esc)
	{
	keys_spec.esc = 0;
	filename[0]=0;
	return 1;
	}	
return 0;	
}

void insert_character_gen (unsigned char what, UINT16 pointer, unsigned char * arr)
{
UINT16 i;
unsigned char temp;
for (i=INPUT_SIZE; i>pointer;i--)
	{
	temp = arr[i-1];
	arr[i] = temp;
	}
arr[pointer] = what;

}

void backspace_gen (UINT16 pointer, unsigned char * arr)
{
UINT16 i;
if (pointer>=0) 
	if (pointer<INPUT_SIZE) 
		for (i=pointer; i<INPUT_SIZE;i++)
			{
			arr[i] = arr[i+1];
			}
}


unsigned char save_file_dialog (unsigned char * filename)
{
unsigned char i;
key_mode = 1;
strcpy(file_name_tmp,filename);
di();
clear_disp_buffer();
if (file_name_tmp[0]==0) 
	{
	for (i=0;i<sizeof(file_name_tmp);i++) file_name_tmp[i]=i;
	file_name_len = 0;
	}
sprintf ((char *)disp_buffer+0,"Save file as:");
sprintf ((char *)disp_buffer+16,file_name_tmp);
disp_buffer[16+file_name_len] = disp_buffer[16+file_name_len] | 0x80;
ei();
if (key_stat==1)
	{
	key_stat = 3;
	if (fil_key_stat_old == 0) insert_character_gen (toupper(key_char), file_name_len, file_name_tmp);
	else file_name_tmp[file_name_len] = toupper(key_char);
	}

if (key_stat==2)
	{
	file_name_tmp[file_name_len] = toupper(key_char);
//	insert_character (key_char, file_pointer);
	file_name_len++;
	key_stat = 0;
	}
fil_key_stat_old = key_stat;
if (keys_spec.bsp)
	{
	if (file_name_len>0)
		{
		file_name_len--;
		backspace_gen(file_name_len,file_name_tmp);
		}
	keys_spec.bsp = 0;
	}
if (keys_spec.ent)
	{
	keys_spec.ent = 0;
	strcpy(filename,file_name_tmp);
	return 1;
	}
if (keys_spec.esc)
	{
	keys_spec.esc = 0;
	filename[0]=0;
	return 1;
	}	
return 0;	
}

UINT16 get_timer (void)
{
UINT16 temp;
IEC0bits.T4IE = 0;
temp = tmr_1ms;
IEC0bits.T4IE = 1;
return temp;
}


unsigned char string_upper (unsigned char * str)
{
while (*str!=0)
	{
	*str = toupper(*str);
	*str++;
	}
}

unsigned char string_lower (unsigned char * str)
{
while (*str!=0)
	{
	*str = tolower(*str);
	*str++;
	}
}

//**********************************************************************************************
//**********************************************************************************************
unsigned char term_shift_out (char * dbuff, char * tbuff);

void terminal_init(void)
{
term_pointer = 0;
}

unsigned char terminal_tasks (char * input, UINT16 * shift)
{
unsigned char len,i;
UINT16 sh;
sh = *shift;
if (input!=0)
	{
	len = strlen(input);
	for (i=0;i<len;i++)
		{
		if (input[i]>(' '-1))
			term_screen_buffer[term_pointer++] = input[i];
		else if (input[i]==BACKSPACE) 
			{
			if (term_pointer>0)
				term_screen_buffer[--term_pointer] = ' ';
			}
		else if ((input[i]==K_UP)|(input[i]==K_DN)|(input[i]==K_LT)|(input[i]==K_RT))
			{
			switch (input[i])
				{
				case K_UP: sh++; break;
				case K_DN: if (sh>0) sh--; break;
				}
			}
		else
			{
			while (term_pointer%TERM_WIDTH!=0)
				term_screen_buffer[term_pointer++] = ' ';
			}
		if (term_pointer==TERM_WIDTH*TERM_LINES)
			{
			term_shift_out(term_screen_buffer,term_buffer);
			term_pointer = term_pointer - TERM_WIDTH;
			}
		}
	}
if (sh<TERM_LINES)
	{
	memcpy(disp_buffer,term_buffer+TBUF_LEN-(TERM_WIDTH*sh),TERM_WIDTH*sh);
	memcpy(disp_buffer+TERM_WIDTH*sh,term_screen_buffer,TERM_WIDTH*(TERM_LINES-sh));
	}
else
	memcpy(disp_buffer,term_buffer+TBUF_LEN-(TERM_WIDTH*sh),TERM_WIDTH*sh);
*shift = sh;
}

unsigned char term_shift_out (char * dbuff, char * tbuff)
{
memmove (tbuff,tbuff+TERM_WIDTH,TBUF_LEN-TERM_WIDTH);
memcpy(tbuff+TBUF_LEN-TERM_WIDTH,dbuff,TERM_WIDTH);
memmove(dbuff,dbuff+TERM_WIDTH,TERM_WIDTH*(TERM_LINES-1));
memset(dbuff + TERM_WIDTH*(TERM_LINES-1),' ',TERM_WIDTH);
}

char term_k_stat (void)
{
if (key_stat == 0)
	return 0;
else 
	return 1;
}

char term_k_char (char * out)
{
if (key_stat==1)
	{
	key_stat = 3;
	if (term_key_stat_old == 0) 
		{
		*out++ = key_char;
		*out++ = 0;
		return 1;
		}
	else 
		{
		*out++ = BACKSPACE;
		*out++ = key_char;
		*out++ = 0;
		return 1;
		}
	}
if (key_stat==2)
	{
//final state
	key_stat = 0;
	}
term_key_stat_old = key_stat;

if (keys_spec.esc)
	{
	*out++ = ESCAPE;
	*out++ = 0;
	keys_spec.esc = 0;
	return 1;
	}

if (keys_spec.bsp)
	{
	*out++ = BACKSPACE;
	*out++ = 0;
	keys_spec.bsp = 0;
	return 1;	
	}

if (keys_spec.ent)
	{
	*out++ = NEW_LINE;
	*out++ = 0;
	keys_spec.ent = 0;
	return 1;
	}

if (keys_spec.rt)
	{
	keys_spec.rt = 0;
	*out++ = K_RT;
	*out++ = 0;
	return 1;
	}
	
if (keys_spec.lt)
	{
	keys_spec.lt = 0;
	*out++ = K_LT;
	*out++ = 0;
	return 1;
	}
	
if (keys_spec.dn)
	{
	keys_spec.dn = 0;
	*out++ = K_DN;
	*out++ = 0;
	return 1;
	}
	
if (keys_spec.up)
	{
	keys_spec.up = 0;
	*out++ = K_UP;
	*out++ = 0;
	return 1;
	}

return 0;
}
